# README #

## Repository Information ##
* Wine Data System
* Version 1

## Project Setup ###
#### Requirements ####
* Grails 3.1.3
* Java SDK/JVM 1.8
* MySQL 5.7
* Gradle 3.1

#### Java VM OPTIONS ####
Some cron jobs will run only at default server. Default server can be `null`, `blank` or `DEFAULT`.
Server Identifier Setting:
```
-DserverIdentifier=DEFAULT
```
Force the Chrome Driver Version (used by Web Driver Manager https://github.com/bonigarcia/webdrivermanager):
```
-Dwdm.chromeDriverVersion=76.0.3809.68
```

## React App Development ##
#### Requirements ####
* Node v20
* NPM version: 10
#### React Modules Installation ####
Run these from client directory
```
npm install --save

npm install babel-runtime
npm install babel-core
```

#### React App Development ####
Run this from client directory
```
npm start
```

#### React App Bundling ####
Run this from client directory
```
npm run build
```

## Error Handler ###
- Filename too long in Windows: Please check build.gradle

## Generate Documentation ##
#### Generate Grails Documentation (Groovy+Java) #####
To generate document, run this from root project dir
```
gradle docs
```
The documentation is in root project dir ``build/docs``

## Tests ##
Make sure these tests pass
```
grails test-app "*OutputService*" -unit
grails test-app "*KeywordsService*" -unit
grails test-app "*ArchiveService*" -unit
grails test-app "*MatcherService*" -unit
grails test-app "*WineServiceSpec*" -unit
grails test-app "*InputServiceSpec*" -unit
grails test-app "wine.alert.Calculator*" -unit
```
