import React from 'react';
import {CleanUpWord} from "../helpers/helper";

class ClickableWord extends React.Component {
    constructor() {
        super();
        this.slicePhrase = this.slicePhrase.bind(this);
        this.wordClick = this.wordClick.bind(this);
    }

    slicePhrase(phrase) {
        if (!phrase) return "";
        let _this = this;
        return phrase.split(new RegExp('[\\s]+', 'g')).map(function(row, i) {
            if (row.indexOf("-") >= 0) {
                return (row.split(new RegExp('[-]+', 'g')).map(function(item, j, arr) {
                    if (j===arr.length-1) {
                        return <span key={j} onClick={_this.wordClick} className="clickable-word">{item} </span>
                    } else {
                        return <span key={j}><span onClick={_this.wordClick} className="clickable-word">{item}</span>-</span>
                    }
                }));
            } else {
                return (
                    <span key={i} onClick={_this.wordClick} className="clickable-word">{row} </span>
                );
            }
        });
    }

    wordClick(e) {
        if (!e.currentTarget) return;
        let word = e.currentTarget.textContent;
        word = CleanUpWord(word);
        if (typeof this.props.onClick === "function") this.props.onClick(word)
    }

    render() {
        let _this = this;
        return (
            <span>{_this.slicePhrase(_this.props.phrase)}</span>
        );
    }
}

export default ClickableWord;