/**
 * Created by marjan on 26/02/18.
 */
import React from 'react';
import Select from 'react-select';
import Modal from 'react-modal';
import * as Constants from '../constants';
import {VIP_VARIETIES} from "../constants";
import Async from "react-select/async";

const customStyles = {
    content : {
        top                   : '50%',
        left                  : '50%',
        right                 : 'auto',
        bottom                : 'auto',
        marginRight           : '-50%',
        transform             : 'translate(-50%, -50%)'
    }
};
const stateFields = ['id', 'wineName', 'color', 'wineType', 'sweetness', 'variety', 'producer', 'country', 'region', 'location', 'locale', 'site'];
const selectStyle = {container: (base) => ({ ...base, width: 200, minWidth: 200, height: 30, display: 'inline-block'}), control: (base) => ({ ...base, height: 30, minHeight: 30}), dropdownIndicator: (base) => ({ ...base, paddingTop: 0, paddingBottom: 0}), clearIndicator: (base) => ({ ...base, paddingTop: 0, paddingBottom: 0}), menuPortal: (base) => ({ ...base, zIndex: 99999})};

class Merge extends React.Component {
    constructor() {
        super();

        this.state = {
            modalIsOpen: false,
            wines: [],
            winesMap: [],
            selectedProps: {},
            newWine: {},
            varieties: [],
            varietiesSelect: [],
            regionCodes: [],
            producers: [],
            wineColors: [],
            wineSweetness: [],
            wineTypes: [],
            countries: [],
            regions: [],
            locations: [],
            locales: [],
            sites: [],
            isSaving: false
        };

        this.getRegionCodes = this.getRegionCodes.bind(this);
        this.getVarieties = this.getVarieties.bind(this);
        this.getColors = this.getColors.bind(this);
        this.getSweetness = this.getSweetness.bind(this);
        this.getTypes = this.getTypes.bind(this);
        this.getCountries = this.getCountries.bind(this);
        this.getRegions = this.getRegions.bind(this);
        this.getLocations = this.getLocations.bind(this);
        this.getLocales = this.getLocales.bind(this);
        this.getSites = this.getSites.bind(this);
        this.getNextId = this.getNextId.bind(this);
        this.handleSelectAll = this.handleSelectAll.bind(this);
        this.handleChange = this.handleChange.bind(this);
        this.handleNewChange = this.handleNewChange.bind(this);
        this.handleRegionCodeChange = this.handleRegionCodeChange.bind(this);
        this.handleProducerSelect = this.handleProducerSelect.bind(this);
        this.handleProducerInputChange = this.handleProducerInputChange.bind(this);
        this.calculateNextId = this.calculateNextId.bind(this);
        this.selectNewWineDb = this.selectNewWineDb.bind(this);
        this.handleSelect = this.handleSelect.bind(this);
        this.isChecked = this.isChecked.bind(this);
        this.openModal = this.openModal.bind(this);
        this.afterOpenModal = this.afterOpenModal.bind(this);
        this.closeModal = this.closeModal.bind(this);
        this.filterOption = this.filterOption.bind(this);
        this.loadProducers = this.loadProducers.bind(this);
        this.getWineDbDetail = this.getWineDbDetail.bind(this);
        this.handleSubmit = this.handleSubmit.bind(this);
        this.mergeWines = this.mergeWines.bind(this);
    }

    componentWillMount() {
        let _this = this;
        let defaultData = Object.assign({}, this.defaultData);
        this.setState({data: defaultData}, function () {
            _this.getRegionCodes();
            _this.getVarieties();
            _this.getColors();
            _this.getSweetness();
            _this.getTypes();

            _this.getCountries();
            _this.getRegions();
            _this.getLocations();
            _this.getLocales();
            _this.getSites();
        });
    }

    handleSelectAll(event) {
        const target = event.target;
        const value = target.type === 'radio' ? (target.checked ? target.value : '') : target.value;
        const index = parseInt(value);

        const states = {};
        const selectedProps = this.state.selectedProps || {};
        for (let i in stateFields) {
            const fieldName = stateFields[i];
            selectedProps[fieldName] = index;
            if (index === this.state.winesMap.length) { // New wine
                states[fieldName] = this.state.newWine[fieldName] || '';
            } else {
                states[fieldName] = this.state.winesMap[index][fieldName] || '';
            }
        }
        states['selectedProps'] = selectedProps;
        this.setState(states);
    }

    handleChange(event) {
        const target = event.target;
        const name = target.name;
        const index = parseInt(target.getAttribute("data-id"));

        if (target.checked) {
            const states = {};
            const selectedProps = this.state.selectedProps || {};
            selectedProps[name] = index;
            states['selectedProps'] = selectedProps;
            if (index === this.state.winesMap.length) { // New
                states[name] = this.state.newWine[name] || '';
            } else {
                states[name] = this.state.winesMap[index][name] || '';
            }
            let _this = this;
            _this.setState(states,function () {
                if (name === 'producer') _this.calculateNextId();
            });
        }
    }

    handleNewChange(event) {
        const target = event.target;
        const name = target.name;
        const value = target.type === 'radio' ? (target.checked ? target.value : '') : target.value;
        const index = parseInt(target.getAttribute("data-id"));

        this.handleSelect(name, value, index);
    }

    handleProducerSelect(val) {
        this.handleSelect('producer', val ? val.value : '', this.state.winesMap.length, this.calculateNextId);
    }

    handleRegionCodeChange(event) {
        const target = event.target;
        const name = target.name;
        const value = target.value;

        this.handleSelect(name, value, this.state.winesMap.length, this.calculateNextId);
    }

    handleProducerInputChange(event) {
        const target = event.target;
        const name = target.name;
        const value = target.value;

        this.handleSelect(name, value, this.state.winesMap.length);
        this.handleSelect('producer', '', this.state.winesMap.length);
    }

    calculateNextId() {
        if (!this.state.selectedProps || this.state.selectedProps['producer'] !== this.state.winesMap.length) {
            return;
        }

        let _this = this;
        _this.getNextId(function (id) {
            _this.selectNewWineDb(id);
        });
    }

    selectNewWineDb(id) {
        const wineDb = typeof id !== 'undefined' ? id : (this.state.newWine['id'] || '');
        this.handleSelect('id', wineDb, this.state.winesMap.length);
    }

    handleSelect(name, value, index, callback) {
        const states = {};
        const selectedProps = this.state.selectedProps || {};
        selectedProps[name] = index;
        states['selectedProps'] = selectedProps;

        if (index === this.state.winesMap.length) { // New wine
            const newWine = this.state.newWine || {};
            newWine[name] = value || '';
            states['newWine'] = newWine;
        }

        states[name] = value || '';
        this.setState(states, callback);
    }

    isChecked(name, id) {
        return this.state.selectedProps && this.state.selectedProps[name] === id
    }

    handleSubmit(e) {
        e.preventDefault();

        let formData = new FormData();
        formData.append('id', this.state.id);
        formData.append('name', this.state.wineName || '');
        formData.append('producer', this.state.producer || '');
        formData.append('variety', this.state.variety || '');
        formData.append('color', this.state.color || '');
        formData.append('sweetness', this.state.sweetness || '');
        formData.append('type', this.state.wineType || '');
        formData.append('wineCountry', this.state.country || '');
        formData.append('wineRegion', this.state.region || '');
        formData.append('wineLocation', this.state.location || '');
        formData.append('wineLocale', this.state.locale || '');
        formData.append('wineSite', this.state.site || '');
        formData.append('producerName', this.state.producerName || '');
        formData.append('nameShow', this.state.producerShow || '');

        let i;
        for (i in this.state.wines) {
            formData.append('wineMerge', this.state.wines[i]);
        }

        this.mergeWines(formData);
    }

    openModal() {
        let _this = this;
        let stateMap = {
            modalIsOpen: true,
            wines: this.props.wines,
            winesMap: [],
            selectedProps: {},
            newWine: {},
            isSaving: false
        };
        for (let i in stateFields) {
            stateMap[stateFields[i]] = '';
        }
        this.setState(stateMap, function () {
            _this.state.wines.map(function(wine, index){
                _this.getWineDbDetail(wine);
            });
        });
    }

    afterOpenModal() {
        //
    }

    closeModal() {
        this.setState({modalIsOpen: false});
    }

    filterOption = ({ label, value, data }, search) => {
        if (search) {
            return label.toLowerCase().startsWith(search.toLowerCase()) || value.toString().includes(search);
        } else {
            return true;
        }
    };

    async loadProducers(search, callback) {
        await fetch(Constants.PRODUCERS_URL, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({
                words: [search]
            }),
            credentials: 'same-origin'
        }).then(function(response) {
            if (!response.ok) {
                throw Error(response.statusText);
            }
            return response.json();
        }).then(function(json) {
            let ps = json.data.map(prod => ({label: prod.name, value: prod.id}));
            callback(ps);
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
        });
    }

    async getRegionCodes() {
        const rawData = await fetch(Constants.REGION_CODES_URL, {
            credentials: 'same-origin'
        });
        const res = await rawData.json();
        let codes = [""];
        if (res.data && res.data.length > 0) codes = codes.concat(res.data);
        this.setState({regionCodes: codes});
    }

    async getWineDbDetail(wineDbId) {
        if (wineDbId) {
            const rawData = await fetch(Constants.WINE_DB_DETAILS + "?id=" + wineDbId, {
                credentials: 'same-origin'
            });
            const res = await rawData.json();
            let winesMap = this.state.winesMap;
            winesMap.push(res.data);
            this.setState({winesMap: winesMap});
        }
    }

    async mergeWines(formData) {
        let _this = this;
        _this.setState({isSaving: true});
        fetch(Constants.MERGE_WINES + "/" + formData.get('id'), {
            method: 'POST',
            body: formData,
            credentials: 'same-origin'
        }).then(function(response) {
            return response.json();
        }).then(function(json) {
            if (json.success) {
                _this.setState({wines: []});
                if (typeof _this.props.callback === "function") {
                    _this.props.callback();
                }
                _this.closeModal();
            } else {
                alert(json.message);
            }
            _this.setState({isSaving: false});
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
            _this.setState({isSaving: false});
        });
    }

    async getVarieties() {
        const rawData = await fetch(Constants.VARIETIES_URL, {
            credentials: 'same-origin'
        });
        const res = await rawData.json();
        let vs = [];
        if (res.data) {
            let rid = 1;
            VIP_VARIETIES.forEach(function (v) {
                let f = res.data.find((e) => {
                    return e.name.toLowerCase() === v
                });
                if (f) vs.push({id: rid++, name: f.name});
            });
            res.data.forEach(function (v) {
                if (VIP_VARIETIES.indexOf(v.name.toLowerCase()) < 0) {
                    vs.push({id: rid++, name: v.name});
                }
            });
        }
        this.setState({varieties: res.data, varietiesSelect: vs});
    }

    async getColors() {
        const rawData = await fetch(Constants.COLORS_URL, {
            credentials: 'same-origin'
        });
        const res = await rawData.json();
        this.setState({wineColors: [""].concat(res.data)});
    }

    async getSweetness() {
        const rawData = await fetch(Constants.SWEETNESS_URL, {
            credentials: 'same-origin'
        });
        const res = await rawData.json();
        this.setState({wineSweetness: res.data});
    }

    async getTypes() {
        const rawData = await fetch(Constants.TYPES_URL, {
            credentials: 'same-origin'
        });
        const res = await rawData.json();
        this.setState({wineTypes: res.data});
    }

    async getCountries() {
        this.setState({isCountriesLoading: true});

        let _this = this;
        await fetch(Constants.COUNTRIES_URL, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            credentials: 'same-origin'
        }).then(function(response) {
            if (!response.ok) {
                throw Error(response.statusText);
            }
            return response.json();
        }).then(function(json) {
            _this.setState({countries: json.data, isCountriesLoading: false});
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
            _this.setState({isCountriesLoading: false});
        });
    }

    async getRegions() {
        this.setState({isRegionsLoading: true});

        let _this = this;
        await fetch(Constants.REGIONS_URL, {
            method: 'GET',
            headers: {
                'Content-Type': 'application/json'
            },
            credentials: 'same-origin'
        }).then(function(response) {
            if (!response.ok) {
                throw Error(response.statusText);
            }
            return response.json();
        }).then(function(json) {
            _this.setState({regions: json.data, isRegionsLoading: false});
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
            _this.setState({isRegionsLoading: false});
        });
    }

    async getLocations() {
        this.setState({isLocationsLoading: true});

        let _this = this;
        await fetch(Constants.LOCATIONS_URL, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            credentials: 'same-origin'
        }).then(function(response) {
            if (!response.ok) {
                throw Error(response.statusText);
            }
            return response.json();
        }).then(function(json) {
            _this.setState({locations: json.data, isLocationsLoading: false});
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
            _this.setState({isLocationsLoading: false});
        });
    }

    async getLocales() {
        this.setState({isLocalesLoading: true});

        let _this = this;
        await fetch(Constants.LOCALES_URL, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            credentials: 'same-origin'
        }).then(function(response) {
            if (!response.ok) {
                throw Error(response.statusText);
            }
            return response.json();
        }).then(function(json) {
            _this.setState({locales: json.data, isLocalesLoading: false});
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
            _this.setState({isLocalesLoading: false});
        });
    }

    async getSites() {
        let _this = this;
        await fetch(Constants.SITES_URL, {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json'
            },
            credentials: 'same-origin'
        }).then(function(response) {
            if (!response.ok) {
                throw Error(response.statusText);
            }
            return response.json();
        }).then(function(json) {
            _this.setState({sites: json.data, isSitesLoading: false});
        }).catch(function(ex) {
            console.log('Parsing data failed!', ex);
            _this.setState({isSitesLoading: false});
        });
    }

    async getNextId(callback) {
        const regionCode = this.state.regionCode && !this.state.producer ? this.state.regionCode : "";
        const producer = this.state.producer ? this.state.producer : "";
        const url = Constants.NEXT_WINE_DB_ID + "?regionCode=" + regionCode + "&producerId=" + producer;
        const rawData = await fetch(url, {
            credentials: 'same-origin'
        });
        const response = await rawData.json();
        if (callback) callback(response.data);
    }

    render() {
        let _this = this;
        return (
            <div>
                <button className="btn btn-default btn-sm" onClick={this.openModal} disabled={this.props.wines.length < 1}>Merge Selected</button>
                <Modal isOpen={this.state.modalIsOpen} onAfterOpen={this.afterOpenModal} onRequestClose={this.closeModal} style={customStyles} contentLabel="Example Modal" ariaHideApp={false}>
                    <div className="row">
                        <div className="col-md-4 text-left">
                            <button type="button" onClick={this.closeModal} className="btn btn-default btn-sm">X</button>
                        </div>
                        <div className="col-md-4 text-center">
                            <h4>Merge Wines</h4>
                        </div>
                        <div className="col-md-4 text-right">
                        </div>
                    </div>

                    <div className="row">
                        <div className="col-md-12">
                            <form onSubmit={this.handleSubmit}>
                                <table className="table table-striped table-wine-merge">
                                    <tbody>
                                    <tr>
                                        <th className="default">#</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'selectAll'+wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="selectAll" value={index} onChange={_this.handleSelectAll} /><strong>Select all</strong></label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label><input type="radio" name="selectAll"
                                                              value={this.state.winesMap.length}
                                                              onChange={this.handleSelectAll} /><strong>Select all</strong></label>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">ID</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'id' + wine.id}>
                                                    <div className="radio">
                                                        <label>
                                                            <input type="radio" name="id" value={wine.id} data-id={index}
                                                                   checked={_this.isChecked('id', index)}
                                                                   onChange={_this.handleChange}/>
                                                            <strong>{wine.id}</strong>
                                                        </label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="id"
                                                           data-id={this.state.winesMap.length}
                                                           checked={this.isChecked('id', this.state.winesMap.length)}
                                                           onChange={this.handleChange}/>
                                                    <input type="text" name="id" className="form-control form-control-merge input-sm"
                                                           value={this.isChecked('id', this.state.winesMap.length) ? this.state.id : ''}
                                                           disabled={true}
                                                           data-id={this.state.winesMap.length}/>
                                                </label>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Name</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'wineName' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="wineName" value={wine.wineName} data-id={index}
                                                                   checked={_this.isChecked('wineName', index)}
                                                                   onChange={_this.handleChange}/>{wine.wineName}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="wineName"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('wineName', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                    <input type="text" name="wineName" className="form-control form-control-merge input-sm"
                                                           data-id={this.state.winesMap.length}
                                                           onChange={this.handleNewChange}/>
                                                </label>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Color</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'color'+wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="color" value={wine.color} data-id={index}
                                                                   checked={_this.isChecked('color', index)}
                                                                   onChange={_this.handleChange}/>{wine.color}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="color"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('color', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <select className="form-control form-control-merge input-sm" id="color" name="color"
                                                        data-id={this.state.winesMap.length}
                                                        onChange={this.handleNewChange}>
                                                    {this.state.wineColors.map(function(row, i) {
                                                        return (
                                                            <option key={i} value={row}>{row || 'Select...'}</option>
                                                        );
                                                    })}
                                                </select>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Type</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'wineType' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="wineType" value={wine.wineType} data-id={index}
                                                                      checked={_this.isChecked('wineType', index)}
                                                                      onChange={_this.handleChange}/>{wine.wineType}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="wineType"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('wineType', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <select className="form-control form-control-merge input-sm" id="wineType" name="wineType"
                                                        data-id={this.state.winesMap.length}
                                                        onChange={this.handleNewChange}>
                                                    {this.state.wineTypes.map(function(row, i) {
                                                        return (
                                                            <option key={i} value={row}>{row || 'Select...'}</option>
                                                        );
                                                    })}
                                                </select>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Sweetness</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'sweetness'+wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="sweetness" value={wine.sweetness} data-id={index}
                                                                      checked={_this.isChecked('sweetness', index)}
                                                                      onChange={_this.handleChange}/>{wine.sweetness}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="sweetness"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('sweetness', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <select className="form-control form-control-merge input-sm" id="sweetness" name="sweetness"
                                                        data-id={this.state.winesMap.length}
                                                        onChange={this.handleNewChange}>
                                                    {this.state.wineSweetness.map(function(row, i) {
                                                        return (
                                                            <option key={i} value={row}>{row || 'Select...'}</option>
                                                        );
                                                    })}
                                                </select>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Variety</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'variety'+wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="variety" value={wine.variety} data-id={index}
                                                                      checked={_this.isChecked('variety', index)}
                                                                      onChange={_this.handleChange}/>{wine.variety}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="variety"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('variety', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Select options={this.state.varietiesSelect}
                                                        isClearable={true}
                                                        filterOption={this.filterOption}
                                                        getOptionValue={option => option.id}
                                                        getOptionLabel={option => option.name}
                                                        styles={selectStyle}
                                                        menuPortalTarget={document.body}
                                                        onChange={(val) => {
                                                            _this.handleSelect('variety', val ? val.name : '', _this.state.winesMap.length);
                                                        }}
                                                />
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Producer</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'producer'+wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="producer" value={wine.producer} data-id={index}
                                                                      checked={_this.isChecked('producer', index)}
                                                                      onChange={_this.handleChange} />{wine.producerName}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="producer"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('producer', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Async cacheOptions loadOptions={this.loadProducers} defaultOptions
                                                       placeholder="Select producer"
                                                       isClearable={true}
                                                       styles={selectStyle}
                                                       menuPortalTarget={document.body}
                                                       onChange={this.handleProducerSelect}
                                                />
                                                <div className="wm-new-producer">
                                                    <select id="region" name="regionCode"
                                                            className="form-control form-control-merge input-sm"
                                                            onChange={this.handleRegionCodeChange}
                                                            disabled={this.state.producer}>
                                                        {this.state.regionCodes.map(function(row, i) {
                                                            return (
                                                                <option key={i} value={row}>{row || 'Select region code...'}</option>
                                                            );
                                                        })}
                                                    </select>
                                                </div>
                                                <div className="wm-new-producer">
                                                    <input type="text" name="producerName"
                                                           className="form-control form-control-merge input-sm"
                                                           placeholder="Producer name"
                                                           onChange={this.handleProducerInputChange}
                                                           disabled={this.state.producer}/>
                                                </div>
                                                <div className="wm-new-producer">
                                                    <input type="text" name="producerShow"
                                                           className="form-control form-control-merge input-sm"
                                                           placeholder="Name show"
                                                           onChange={this.handleProducerInputChange}
                                                           disabled={this.state.producer}/>
                                                </div>
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Country</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'country' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="country" value={wine.country} data-id={index}
                                                                      checked={_this.isChecked('country', index)}
                                                                      onChange={_this.handleChange}/>{wine.country}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="country"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('country', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Select options={this.state.countries.map(el => ({label: el, value: el}))}
                                                        isClearable={true}
                                                        styles={selectStyle}
                                                        menuPortalTarget={document.body}
                                                        onChange={(val) => {
                                                            _this.handleSelect('country', val ? val.label : '', _this.state.winesMap.length);
                                                        }}
                                                />
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Region</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'region' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="region" value={wine.region} data-id={index}
                                                                      checked={_this.isChecked('region', index)}
                                                                      onChange={_this.handleChange}/>{wine.region}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="region"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('region', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Select options={this.state.regions.map(el => ({label: el.region, value: el}))}
                                                        isClearable={true}
                                                        styles={selectStyle}
                                                        menuPortalTarget={document.body}
                                                        onChange={(val) => {
                                                            _this.handleSelect('region', val ? val.label : '', _this.state.winesMap.length);
                                                        }}
                                                />
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Sub-Region</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'location' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="location" value={wine.location} data-id={index}
                                                                      checked={_this.isChecked('location', index)}
                                                                      onChange={_this.handleChange}/>{wine.location ? wine.location : '-'}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="location"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('location', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Select options={this.state.locations.map(el => ({label: el.location, value: el}))}
                                                        isClearable={true}
                                                        styles={selectStyle}
                                                        menuPortalTarget={document.body}
                                                        onChange={(val) => {
                                                            _this.handleSelect('location', val ? val.label : '', _this.state.winesMap.length);
                                                        }}
                                                />
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Appellation</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'locale' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="locale" value={wine.locale} data-id={index}
                                                                      checked={_this.isChecked('locale', index)}
                                                                      onChange={_this.handleChange}/>{wine.locale ? wine.locale : '-'}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="locale"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('locale', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Select options={this.state.locales.map(el => ({label: el.locale, value: el}))}
                                                        isClearable={true}
                                                        styles={selectStyle}
                                                        menuPortalTarget={document.body}
                                                        onChange={(val) => {
                                                            _this.handleSelect('locale', val ? val.label : '', _this.state.winesMap.length);
                                                        }}
                                                />
                                            </div>
                                        </td>
                                    </tr>
                                    <tr>
                                        <th className="default">Sub-Appellation</th>
                                        {this.state.winesMap.map(function(wine, index){
                                            return (
                                                <td key={'site' + wine.id}>
                                                    <div className="radio">
                                                        <label><input type="radio" name="site" value={wine.site} data-id={index}
                                                                      checked={_this.isChecked('site', index)}
                                                                      onChange={_this.handleChange} />{wine.site ? wine.site : '-'}</label>
                                                    </div>
                                                </td>
                                            );
                                        })}
                                        <td>
                                            <div className="radio">
                                                <label>
                                                    <input type="radio" name="site"
                                                              data-id={this.state.winesMap.length}
                                                              checked={this.isChecked('site', this.state.winesMap.length)}
                                                              onChange={this.handleChange}/>
                                                </label>
                                                <Select options={this.state.sites.map(el => ({label: el.site, value: el}))}
                                                        isClearable={true}
                                                        styles={selectStyle}
                                                        menuPortalTarget={document.body}
                                                        onChange={(val) => {
                                                            _this.handleSelect('site', val ? val.label : '', _this.state.winesMap.length);
                                                        }}

                                                />
                                            </div>
                                        </td>
                                    </tr>
                                    </tbody>
                                </table>
                                <input type="submit" value="Submit" className="btn btn-default btn-sm pull-right" disabled={this.state.isSaving} />
                            </form>
                        </div>
                    </div>
                </Modal>
            </div>
        );
    }
}

export default Merge;