var path = require('path');

module.exports = {
    entry: ['./app/index.jsx'],
    output: {
        path: path.join(__dirname, '../grails-app/assets/javascripts'),
        publicPath: '/assets/',
        filename: 'bundle.js'
    },
    resolve: {
        extensions: ['.js', '.jsx']
    },
    module: {
        rules: [
            {
                test: /\.(?:js|jsx|mjs|cjs)$/,
                include: path.join(__dirname, 'app'),
                exclude: {
                    and: [/node_modules/], // Exclude libraries in node_modules ...
                    not: [
                        // Except for a few of them that needs to be transpiled because they use modern syntax
                        /unfetch/,
                        /d3-array|d3-scale/,
                        /@hapi[\\/]joi-date/,
                    ]
                },
                use: {
                    loader: 'babel-loader',
                    options: {
                        presets: [
                            ['@babel/preset-env'],
                            ['@babel/preset-react']
                        ]
                    }
                }
            }
        ]
    }
};
