// This is a manifest file that'll be compiled into application.js.
//
// Any JavaScript file within this directory can be referenced here using a relative path.
//
// You're free to add application-wide JavaScript to this file, but it's generally better
// to create separate JavaScript files as needed.
//
//= encoding UTF-8
//= require jquery-2.2.0.min
//= require bootstrap
//= require vendor/bootstrap2-toggle
//= require vendor/freeze-table
//= require rollup
//= require_self

if (typeof jQuery !== 'undefined') {
    (function ($) {
        $('#spinner').ajaxStart(function () {
            $(this).fadeIn();
        }).ajaxStop(function () {
            $(this).fadeOut();
        });

        $(".checkbox-select-all").change(function () {  //"select all" change
            var status = this.checked; // "select all" checked status
            var elSelector = $(this).attr("data-el-selector");
            $('.' + elSelector).each(function () { //iterate all listed checkbox items
                $(this).prop("checked", status).change(); //change ".checkbox" checked status
            });
        });

        $('.group-check').change(function () { //".checkbox" change
            var pSelector = $(this).attr("data-el-parent");
            var elGroup = $(this).attr("data-el-group");
            //uncheck "select all", if one of the listed checkbox item is unchecked
            if (this.checked == false) { //if this item is unchecked
                $("." + pSelector)[0].checked = false; //change "select all" checked status to false !!!do not use jquery prop
            }

            //check "select all" if all checkbox items are checked
            if ($('.' + elGroup + ':checked').length == $('.' + elGroup).length) {
                $("." + pSelector)[0].checked = true; //change "select all" checked status to true !!!do not use jquery prop
            }
        }).change(); // trigger on startup

        $(document).on("change", ".wine-match-check", function () {
            var labEl = $(this).closest("td").find("label").first();
            if (this.checked == false) { //if this item is unchecked
                labEl.text("History");
            } else {
                labEl.text("Keyword");
            }
        }).change();

        $("body").tooltip({
            selector: '[data-toggle="tooltip"]',
            trigger: 'hover'
        });

        $(".confirm-delete").on("click", function (e) {
            e.preventDefault();
            var result = confirm("Are you sure you want to delete?");
            if (result) {
                window.location.href = $(this).attr('href');
            }
        });

        var freezeTableHeight = function () {
            var navbarHeight = $('.navbar').length > 0 ? $('.navbar').outerHeight() : 0;
            var navHeight = $(".nav").length > 0 ? $(".nav").outerHeight() : 0;
            var contentTitleHeight = $(".content-title").length > 0 ? $(".content-title").outerHeight() : 0;
            var footerHeight = $(".footer").length > 0 ? $(".footer").outerHeight() : 0;
            var paginationHeight = $(".pagination").length > 0 ? $(".pagination").outerHeight() + 18 : 0;
            return $(window).height() - (navbarHeight + navHeight + contentTitleHeight + paginationHeight + footerHeight);
        };

        if ($(".freeze-table").length > 0) {
            $(".freeze-table").height(freezeTableHeight());
            $(".freeze-table").freezeTable({
                'scrollBar': true,
                'shadow': true,
                'scrollable': true,
            });
            $(".freeze-table").freezeTable('update');
        }

        if ($(".freeze-table__2-columns").length > 0) {
            $(".freeze-table__2-columns").height(freezeTableHeight());
            $(".freeze-table__2-columns").freezeTable({
                'columnNum': '2',
                'shadow': true,
                'scrollable': true,
            });
            $(".freeze-table__2-columns").freezeTable('update');
        }

        $(window).on("resize", function () {
            if ($(".freeze-table").length > 0) {
                $(".freeze-table").height(freezeTableHeight());
                $(".freeze-table").freezeTable('update');
            }
            if ($(".freeze-table__2-columns").length > 0) {
                $(".freeze-table__2-columns").height(freezeTableHeight());
                $(".freeze-table__2-columns").freezeTable('update');
            }
        });

        $(".js-terminate-crawler").on("click", function () {
            var ids = [];
            $('input[name="id"]:checked').each(function (e) {
                ids.push(Number($(this).val()));
            });
            var conf = confirm($(this).data('confirmation'));
            if (conf === true) {
                $.post($(this).data('url'), {id: ids}, function (resp) {
                    if (resp.errors && resp.errors.length > 0) {
                        var e = "";
                        var i;
                        for (i in resp.errors) {
                            e += resp.errors[i] + "\n";
                        }
                        alert(e);
                    }
                    location.reload();
                }, "json").fail(function (resp) {
                    if (resp.responseJSON) alert(resp.responseJSON.message);
                    location.reload();
                });
            }
        });
    })(jQuery);
}
