if (typeof jQuery !== 'undefined') {
    (function($) {
        var getRollUpLogsInterval;
        var _tr_running = $('.js-tr-running');

        if (_tr_running.length > 0) {
            getRollUpLogsInterval = setInterval(getRollUpLogs, 2500);
        }

        function ReloadPage() {
            clearInterval(getRollUpLogsInterval);
            location.reload();
        }

        $("button.js-rollup__run").on("click", function () {
            var button = $(this);
            var url = button.data("url");
            var conf = confirm(button.data("confirm-msg"));
            if (conf === true) {
                button.prop('disabled', true);
                $.post(url, function(resp) {
                    // reload to make sure new log shows up
                    setTimeout(ReloadPage, 1000);
                    button.prop('disabled', false);
                }, "json").fail(function(resp) {
                    alert(resp.responseJSON.message);
                    button.prop('disabled', false);
                });
            }
        });

        function getRollUpLogs() {
            _tr_running = $('.js-tr-running');

            if (_tr_running.length === 0) {
                ReloadPage();
                return;
            }

            $.each(_tr_running, function (key, val) {
                var _tr = $(this);
                var _url = _tr.data('url');

                $.get(_url, function(resp) {
                    _tr.find('.js-td-message').html(resp.message);
                    if(resp.status === "SUCCESS"){
                        _tr.removeClass("js-tr-running");
                        ReloadPage();
                    }
                });
            });
        }
    })(jQuery);
}
