package wine.alert

import enums.Status

class CrawlLog {

    String code
    String url
    Status status
    Integer attempt
    String message
    String causedBy

    Date dateCreated

    static constraints = {
        url nullable: true, blank: true
        status nullable: true
        attempt nullable: true
        message nullable: true, blank: true
        causedBy nullable: true, blank: true
    }

    static mapping = {
        url sqlType: "text"
        message sqlType: "text"
        causedBy sqlType: "text"
    }
}
