package wine.alert

class CrawlUrl {

    static belongsTo = [webCrawler: WebCrawler]

    String url
    String paginationParams // additional url params
    String pagesToScan // Separated by comma

    // PaginationType.PAGE_NUMBER
    Integer firstPage
    Integer lastPage

    // PaginationType.LIMIT_OFFSET
    Integer itemsPerPage
    Integer lastOffset

    static constraints = {
        // pagination
        paginationParams nullable: true, blank: true
        pagesToScan nullable: true, blank: true

        firstPage nullable: true
        lastPage nullable: true

        itemsPerPage nullable: true
        lastOffset nullable: true
    }

    static mapping = {
        url sqlType: "text"
    }
}
