package wine.alert

import enums.Status
import enums.ValidationType

class Matched {

    WebCrawler webCrawler
    String wineAlertId
    String description
    String keyword
    ValidationType validationType = ValidationType.AUTO
    Status status = Status.DRAFT
    boolean skipped = false

    User createdBy
    User modifiedBy

    Date dateCreated
    Date lastUpdated

    static constraints = {
        wineAlertId length: 14
        keyword nullable: true
        createdBy nullable: true
        modifiedBy nullable: true
    }

    static mapping = {
        wineAlertId index: 'wine_alert_id_idx'
        description sqlType: "text"
        keyword sqlType: "text"
        skipped defaultValue: "0"
    }
}
