package wine.alert

class RetailerGroup {

    static hasMany = [webCrawlers: WebCrawler]

    static transients = ['retailersSize']

    String name

    String feedUrl
    String feedMethod
    String feedUsername
    String feedPassword
    String feedRegion
    String charset
    String clientIdPattern

    Date dateCreated
    Date lastUpdated

    transient boolean running = false

    static constraints = {
        feedMethod nullable: true
        feedUsername nullable: true
        feedPassword nullable: true
        feedRegion nullable: true
        charset nullable: true
    }

    /**
     * Gets retailer size
     * @return Integer
     */
    Integer getRetailersSize() {
        return webCrawlers.size()
    }
}
