package wine.alert

import enums.AliasType
import org.apache.commons.lang.StringUtils

class WordAlias {

    static transients = ['aliases', 'normalAliases']

    String word
    String alias
    AliasType aliasType

    Date dateCreated
    Date lastUpdated

    static constraints = {
        word unique: "aliasType"
        alias sqlType: "text"
    }

    List<String> getAliases() {
        List<String> aliases = StringUtils.isNotBlank(alias) ? alias.toLowerCase()?.tokenize("|") : new ArrayList<String>()
        return aliases?.unique()
    }

    List<String> getNormalAliases() {
        return StringUtils.isNotBlank(alias) ? alias?.tokenize("|") : new ArrayList<String>()
    }
}
