package wine.db

class Country {

    static hasMany = [regions: Region]

    String name
    String isoCode2
    String isoCode3

    String mongoId

    Date dateCreated
    Date lastUpdated

    transient beforeInsert = {
        throw new RuntimeException('insert not allowed')
    }

    transient beforeUpdate = {
        throw new RuntimeException('update not allowed')
    }

    transient beforeDelete = {
        throw new RuntimeException('delete not allowed')
    }

    static constraints = {
        isoCode2 unique: true, length: 10
        isoCode3 unique: true, nullable: true, length: 10
        mongoId unique: true, nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
    }
}
