package wine.db

class DeletedWine {

    Long id

    String objectId
    String vintage
    String maturity

    String ratingLow
    String ratingHigh
    String ratingQ

    String imageUrl

    String wineDbId
    String appellationId

    String mongoId
    String wineNId
    String wineNRating

    Date dateCreated

    static constraints = {
        objectId length: 12
        maturity nullable: true, blank: true
        ratingLow nullable: true, blank: true, length: 10
        ratingHigh nullable: true, blank: true, length: 10
        ratingQ nullable: true, blank: true, length: 10
        imageUrl nullable: true, blank: true
        appellationId nullable: true
        mongoId nullable: true
        wineNId nullable: true, length: 100
        wineNRating nullable: true, blank: true, length: 10
    }

    static mapping = {
        datasource "wineDatabase"
        imageUrl sqlType: "text"
        wineNId column: 'wine_n_id'
        wineNRating column: 'wine_n_rating'
    }
}
