package wine.db

class DeletedWineDb {

    Long id

    String objectId
    String name
    String color
    String type
    String sweetness
    String variety
    String note

    String producerId

    String wineCountry
    String wineRegion
    String wineLocation
    String wineLocale
    String wineSite
    String wineNId

    Date dateCreated

    static constraints = {
        objectId length: 9
        name nullable: true, blank: true
        color nullable: true, blank: true
        type nullable: true, blank: true
        sweetness nullable: true, blank: true
        variety nullable: true, blank: true
        note nullable: true
        wineCountry nullable: true
        wineRegion nullable: true
        wineLocation nullable: true
        wineLocale nullable: true
        wineSite nullable: true
        wineNId nullable: true, length: 100
    }

    static mapping = {
        datasource "wineDatabase"
        name sqlType: "text"
        note sqlType: "text"
        wineNId column: 'wine_n_id'
    }
}
