package wine.db

import wine.db.enums.Source

class Producer {

    static hasOne = [producerKeyword: ProducerKeyword]
    static hasMany = [wineDbs: WineDb, producerNoises: ProducerNoise]

    String id
    String name
    String nameShow

    String mongoId
    Source source

    Date dateCreated
    Date lastUpdated

    static constraints = {
        producerKeyword nullable: true

        id length: 6
        name nullable: true
        nameShow nullable: true

        mongoId unique: true, nullable: true
        source nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
        id column: 'id', generator: 'assigned'
        name sqlType: "text"
        nameShow sqlType: "text"
    }
}
