package wine.db

class Region {

    static hasMany = [locations: Location]

    String name
    Country country

    String mongoId

    Date dateCreated
    Date lastUpdated

    transient beforeInsert = {
        throw new RuntimeException('insert not allowed')
    }

    transient beforeUpdate = {
        throw new RuntimeException('update not allowed')
    }

    transient beforeDelete = {
        throw new RuntimeException('delete not allowed')
    }

    static constraints = {
        mongoId unique: true, nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
    }
}
