package wine.db

class Retailer {

    static hasMany = [retailerWines: RetailerWine]

    String code
    String name
    String email
    String webUrl
    String address
    String addressExtended
    String postalCode
    String city
    String state
    String phone
    String shipTo

    Country country

    Boolean active = true

    Date dateCreated
    Date lastUpdated

    static constraints = {
        code unique: true
        name nullable: true, blank: true
        email nullable: true, blank: true
        webUrl nullable: true, blank: true
        address nullable: true, blank: true
        addressExtended nullable: true, blank: true
        postalCode nullable: true, blank: true
        city nullable: true, blank: true
        state nullable: true, blank: true
        phone nullable: true, blank: true
        shipTo nullable: true, blank: true

        country nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
        webUrl sqlType: "text"
        active defaultValue: "1"
        address sqlType: "text"
        addressExtended sqlType: "text"
    }
}
