package wine.db

class RetailerWine {

    String name
    Integer quantity
    String taxStatus
    String description
    String sku
    String url
    String currency
    BigDecimal price
    BigDecimal usdPrice

    BottleSize bottleSize
    Retailer retailer
    Wine wine

    Boolean available = true
    Date lastAvailable

    Date dateCreated
    Date lastUpdated

    static constraints = {
        wine nullable: true
        name nullable: true, blank: true
        quantity nullable: true
        taxStatus nullable: true, blank: true
        description nullable: true, blank: true
        sku nullable: true, blank: true
        url nullable: true, blank: true
        currency nullable: true, blank: true
        usdPrice nullable: true
        lastAvailable nullable: true

        retailer(unique: ['wine', 'bottleSize', 'sku'])
    }

    static mapping = {
        datasource "wineDatabase"
        name index: 'name_idx'
        description sqlType: "text"
        url sqlType: "text"
        available defaultValue: "1"
    }
}
