package wine.db

class Vintage {

    String id
    String name

    Date dateCreated
    Date lastUpdated

    transient beforeInsert = {
        throw new RuntimeException('insert not allowed')
    }

    transient beforeUpdate = {
        throw new RuntimeException('update not allowed')
    }

    transient beforeDelete = {
        throw new RuntimeException('delete not allowed')
    }

    static constraints = {
        id length: 3
        name unique: true
    }

    static mapping = {
        datasource "wineDatabase"
        id column: 'id', generator: 'assigned'
    }
}
