package wine.db

import wine.db.enums.Source

class WineDuplication {

    Wine wine
    String mongoId

    Source source

    Date dateCreated
    Date lastUpdated

    static constraints = {
        mongoId unique: true, validator: { val, obj ->
            if (val) {
                if (Wine.wineDatabase.countByMongoId(val) > 0) {
                    return ['wineDuplication.mongoId.isPrimaryWine']
                }
            }
            return true
        }

        source nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
    }
}
