package wine.db

import wine.db.enums.Source

class WineKeyword {

    static transients = ['wineDbId', 'wineDbDescription']

    WineDb wineDb
    String pattern
    String producerKeyword
    String baseKeyword
    String appellationKeyword
    String colorKeyword
    String commonModifiersKeyword
    String modifiersKeyword
    String customNotKeyword
    String globalNotKeyword

    Source source

    Date dateCreated
    Date lastUpdated

    static constraints = {
        wineDb unique: true
        producerKeyword nullable: true
        baseKeyword nullable: true
        appellationKeyword nullable: true
        colorKeyword nullable: true
        commonModifiersKeyword nullable: true
        modifiersKeyword nullable: true
        customNotKeyword nullable: true
        globalNotKeyword nullable: true

        source nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
        pattern sqlType: "text"
        producerKeyword sqlType: "text"
        globalNotKeyword sqlType: "text"
        modifiersKeyword sqlType: "text"
    }

    def getWineDbId() {
        return wineDb.id
    }

    def getWineDbDescription() {
        return wineDb.getDescription()
    }
}
