package wine.db

import enums.Status

import java.text.SimpleDateFormat

class WineLabel {

    String imageId
    String imageExt
    String name
    String vintage

    Wine wine

    Date submittedDate

    Status status = Status.WAIT_FOR_APPROVAL
    Date statusUpdated

    Date dateCreated
    Date lastUpdated

    static constraints = {
        statusUpdated nullable: true
        wine nullable: true
    }

    static mapping = {
        datasource "wineDatabase"
    }

    String getImageName()  {
        return imageId + "." + imageExt
    }

    String getImageDir() {
        String dir = ""
        if (status == Status.APPROVED) {
            return getImageName()
        }

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM")
        dir += sdf.format(submittedDate)

        return dir + File.separator + getImageName()
    }
}
