import enums.CsvQuoteMode
import enums.PageType
import enums.Separator
import enums.WineProperty
import wine.alert.CrawlProperty
import wine.alert.CrawlValidator
import wine.alert.PostProcessing
import wine.alert.WebCrawler

/**
 * Created by marjan on 1/22/17.
 */
class CsvInit {
    public static init() {

        WebCrawler abbelio = WebCrawler.findByCode("abbelio")
        if (abbelio == null) {
            abbelio = new WebCrawler(code: "abbelio", name: "Abbelio", url: "https://www.abbelio-wines.com.hk/_data/winealert.csv", pageType: PageType.CSV,
                    rowStart: 1, outputTitle: "Name|Price|Vintage|Bottle Size|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: abbelio, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: abbelio, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: abbelio, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: abbelio, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: abbelio, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
        }

        WebCrawler brown = WebCrawler.findByCode("brown")
        if (brown == null) {
            brown = new WebCrawler(code: "brown", name: "Brown Deryb", url: "http://www.brownderby.com/admin/csvwinelist.php", pageType: PageType.CSV,
                    rowStart: 1, outputTitle: "Number|Country|Region|Producer|Varietal|Wine Name|Color|Size|Vintage|Price").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.PRODUCER, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.VARIETAL, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.COLOR, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: brown, wineProperty: WineProperty.PRICE, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler farr = WebCrawler.findByCode("farr")
        if (farr == null) {
            farr = new WebCrawler(code: "farr", name: "Farr Vintners", url: "http://www.farrvintners.com/winelist_csv.php", pageType: PageType.CSV, charsetEncoding: "ISO-8859-1",
                    outputTitle: "Region|Color|Vintage|Wine Name|Size|Size Description|Details|Cases|Bottles|GBP Price|Per|Units|GBP Unit Price|Score|Author|Flag").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.COLOR, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Size Description", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.DESCRIPTION, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Cases", dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Bottles", dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Per", dataOutput: true, propertyIndex: 10).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Units", dataOutput: true, propertyIndex: 11).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "GBP Unit Price", dataOutput: true, propertyIndex: 12).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Score", dataOutput: true, propertyIndex: 13).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Author", dataOutput: true, propertyIndex: 14).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: farr, wineProperty: WineProperty.CUSTOM, customLabel: "Flag", dataOutput: true, propertyIndex: 15).save(flush: true, failOnError: true)
        }

        WebCrawler finewineselect = WebCrawler.findByCode("finewineselect")
        if (finewineselect == null) {
            finewineselect = new WebCrawler(code: "finewineselect", name: "Fine Wine Select", url: "http://file1.npage.de/004506/68/html/winealert-template.csv", pageType: PageType.CSV,
                    delimiter: Separator.SEMICOLON, charsetEncoding: "ISO-8859-1", outputTitle: "Name|Bottle Size|Price|URL|VAT").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: finewineselect, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: finewineselect, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            def price = new CrawlProperty(webCrawler: finewineselect, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: finewineselect, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            def vat = new CrawlProperty(webCrawler: finewineselect, wineProperty: WineProperty.CUSTOM, customLabel: "VAT", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)

            new PostProcessing(processName: "replaceText", processArgs: ",\n.", processOrder: 0, crawlProperty: price).save(flush: true, failOnError: true)
            new PostProcessing(processName: "replaceWithText", processArgs: "Includes VAT", processOrder: 0, crawlProperty: vat).save(flush: true, failOnError: true)

            new CrawlValidator(webCrawler: finewineselect, processName: "minTotalRecords", processArgs: "490", processOrder: 0).save(flush: true, failOnError: true)
        }

        WebCrawler jjbuckley = WebCrawler.findByCode("jjbuckley")
        if (jjbuckley == null) {
            jjbuckley = new WebCrawler(code: "jjbuckley", name: "JJ Buckley", url: "https://www.jjbuckley.com/datafeed/oakmasterfeed.csv", pageType: PageType.CSV, csvQuoteMode: CsvQuoteMode.NONE,
                    rowStart: 1, charsetEncoding: "ISO-8859-1", outputTitle: "Product ID|Product Name|Product Description|Product Price|Sale Price|Bottle Size|Color|Vintage|Varietal|Winery|Product URL").save(flush: true, failOnError: true)

            def manuf = new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.CUSTOM, customLabel: "Manufacturer Number", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.DESCRIPTION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.CUSTOM, customLabel: "Product Price", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.COLOR, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.VARIETAL, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.CUSTOM, customLabel: "Winery", dataOutput: true, propertyIndex: 10).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: jjbuckley, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 11).save(flush: true, failOnError: true)

            new PostProcessing(processName: "concatWithIndexAndText", processArgs: "1\n;", processOrder: 0, crawlProperty: manuf).save(flush: true, failOnError: true)
        }

        WebCrawler timeless = WebCrawler.findByCode("timeless")
        if (timeless == null) {
            timeless = new WebCrawler(code: "timeless", name: "Timeless Wines", url: "http://www.timelesswines.com/feeds/shoppingcom-export.csv", pageType: PageType.CSV,
                    rowStart: 1, charsetEncoding: "ISO-8859-1", outputTitle: "Name|URL|Current Price|Stock Availability|Manufacturer|Original Price|Description").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.CUSTOM, customLabel: "Current Price", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.CUSTOM, customLabel: "Stock Availability", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.CUSTOM, customLabel: "Manufacturer", dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.CUSTOM, customLabel: "Original Price", dataOutput: true, propertyIndex: 11).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: timeless, wineProperty: WineProperty.DESCRIPTION, dataOutput: true, propertyIndex: 14).save(flush: true, failOnError: true)
        }

        WebCrawler nvc = WebCrawler.findByCode("nvc")
        if (nvc == null) {
            nvc = new WebCrawler(code: "nvc", name: "Napa Valley Connection", pageType: PageType.CSV,
                    url: "https://docs.google.com/spreadsheets/d/1MHAQOOQqSkm8cdMBLvXqXFp1ouzzoAZKeZ8PHiRues4/export?format=csv&id=1MHAQOOQqSkm8cdMBLvXqXFp1ouzzoAZKeZ8PHiRues4&gid=0",
                    rowStart: 1, charsetEncoding: "ISO-8859-1", outputTitle: "Name|Description|Extra Description|Vintage|Bottle Size|Price|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: nvc, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: nvc, wineProperty: WineProperty.DESCRIPTION, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: nvc, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: nvc, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: nvc, wineProperty: WineProperty.PRICE, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: nvc, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)

        }

        WebCrawler aabalat = WebCrawler.findByCode("aabalat")
        if (aabalat == null) {
            aabalat = new WebCrawler(code: "aabalat", name: "Aabalat Fine and Rare Wines", pageType: PageType.CSV, baseUrl: "https://aabalat.com",
                    url: "https://aabalat.com/wine/export/file", rowStart: 1,
                    outputTitle: "Name|SKU|Price|URL|Quantity").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: aabalat, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: aabalat, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: aabalat, wineProperty: WineProperty.PRICE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: aabalat, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: aabalat, wineProperty: WineProperty.CUSTOM, customLabel: "Quantity", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)

        }

    }
}
