import enums.DataPlacement
import enums.PageType
import enums.PaginationType
import enums.WineProperty
import wine.alert.CrawlProperty
import wine.alert.PostProcessing
import wine.alert.WebCrawler

/**
 * Created by marjan on 1/18/17.
 */
class HtmlInit {
    public static init() {

        WebCrawler b21com = WebCrawler.findByCode("b-21")
        if (b21com == null) {
            b21com = new WebCrawler(code: "b-21", name: "B-21", url: "http://www.b-21.com/searchprods.asp", pageType: PageType.HTML,
                    selector: "div.data2 > table > tbody > tr", detailsLinkSelector: "a.prodstitle[href]", currencyCode: "\$",
                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "pagenumber", lastPage: 282,
                    paginationParams: "searchstring=&val=0", maxThreads: 5,
                    outputTitle: "Name|URL|Price").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.WINE_TITLE, selectors: "td table a.prodstitle", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.REGULAR_PRICE, selectors: "td span.prodsprice > s").save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.SELL_PRICE, selectors: "td span.prodsprice", noises: "s", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.COUNTRY, selectors: "td table td:contains(Country: ) strong").save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.REGION, selectors: "td table td:contains(Region: ) strong").save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.SUB_REGION, selectors: "td table td:contains(Sub-Region: ) strong").save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: b21com, wineProperty: WineProperty.URL, selectors: "a.prodstitle[href]", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
        }

//        WebCrawler applejack = WebCrawler.findByCode("applejack")
//        if (applejack == null) {
//            applejack = new WebCrawler(code: "applejack", name: "Applejack", url: "https://www.applejack.com/websearch_results.html", pageType: PageType.HTML,
//                    selector: "div.product-list div", detailsLinkSelector: "a.rebl15[href]", currencyCode: "\$", charsetEncoding: "ISO-8859-1", baseUrl: "https://www.applejack.com",
//                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "page", lastPage: 110, paginationParams: "sortby=sort_item_order&l=100", maxThreads: 5,
//                    outputTitle: "Name|URL|Price|Regular Price").save(flush: true, failOnError: true)
//
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.WINE_TITLE, selectors: "td table a.rebl15", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.REGION, selectors: "td table td div.rstxt:contains(Region: )", textToRemove: "Region: ", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.SUB_REGION, selectors: "td table td div.rstxt:contains(Subregion: )", textToRemove: "Subregion: ", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.VARIETAL, selectors: "td table td div.rstxt:contains(Varietal: )", textToRemove: "Varietal: ", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.SELL_PRICE, selectors: "td.rpwrap div div:eq(0)", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.REGULAR_PRICE, selectors: "td.rpwrap div div strike", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: applejack, wineProperty: WineProperty.URL, selectors: "a.rebl15[href]", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
//        }

        WebCrawler bpwine = WebCrawler.findByCode("bpwine")
        if (bpwine == null) {
            bpwine = new WebCrawler(code: "bpwine", name: "BP Wine", url: "http://www.bpwine.com/listing.html?query=*", pageType: PageType.HTML,
                    selector: "table.product-listing tr", detailsLinkSelector: "td.product-title a:eq(0)[href]", currencyCode: "\$", baseUrl: "https://www.benchmarkwine.com",
                    usePagination: false, outputTitle: "Name|Rating|Price|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: bpwine, wineProperty: WineProperty.WINE_TITLE, selectors: "td.product-title", noises: "small, a", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bpwine, wineProperty: WineProperty.RATING, selectors: "td.product-rating-condition a strong", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bpwine, wineProperty: WineProperty.PRICE, selectors: "td.product-price span", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bpwine, wineProperty: WineProperty.URL, selectors: "td.product-title a:eq(0)[href]", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
        }

        // Website changed
//        WebCrawler bruun = WebCrawler.findByCode("bruun")
//        if (bruun == null) {
//            bruun = new WebCrawler(code: "bruun", name: "Bruun Rasmussen", url: "http://www.bruun-rasmussen.dk/search.do", pageType: PageType.HTML, charsetEncoding: "ISO-8859-1",
//                    selector: "table.itemListGallery tr td.item div", detailsLinkSelector: "div table td.itemListItemHeadline a[href]", currencyCode: "€", baseUrl: "https://www.benchmarkwine.com",
//                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "pg", lastPage: 13, paginationParams: "cid=2838", maxThreads: 10,
//                    outputTitle: "Name|Price|URL").save(flush: true, failOnError: true)
//
//            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.WINE_TITLE, selectors: "div table td.itemListItemHeadline a span", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.PRICE, selectors: "div table tr:eq(4) td.itemListItemInfo", noises: "strong", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
//            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.URL, selectors: "div table td.itemListItemHeadline a[href]", noises: "strong", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
//        }


        WebCrawler cellarit = WebCrawler.findByCode("cellarit")
        if (cellarit == null) {
            cellarit = new WebCrawler(code: "cellarit", name: "Cellarit Wines", url: "http://www.cellarit.com.au/winesearcher.aspx", pageType: PageType.HTML,
                    selector: "table tr", rowStart: 1, currencyCode: "\$", baseUrl: "http://www.cellarit.com.au",
                    usePagination: false, outputTitle: "Name|Vintage|Price|URL|PROD ID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: cellarit, wineProperty: WineProperty.WINE_TITLE, selectors: "td:eq(0)", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cellarit, wineProperty: WineProperty.VINTAGE, selectors: "td:eq(1)", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cellarit, wineProperty: WineProperty.PRICE, selectors: "td:eq(2)", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cellarit, wineProperty: WineProperty.CUSTOM, customLabel: "URL", selectors: "td:eq(3)", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            def custom = new CrawlProperty(webCrawler: cellarit, wineProperty: WineProperty.PROD_ID, selectors: "td:eq(3)", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)

            new PostProcessing(processName: "replaceWithIndexTakeLeft", processArgs: "4\n38", processOrder: 0, crawlProperty: custom).save(flush: true, failOnError: true)
            new PostProcessing(processName: "removeText", processArgs: "https://www.cellarit.com.au/wine-", processOrder: 1, crawlProperty: custom).save(flush: true, failOnError: true)
            new PostProcessing(processName: "concatWithText", processArgs: ";", processOrder: 2, crawlProperty: custom).save(flush: true, failOnError: true)

        }

        WebCrawler schneiders = WebCrawler.findByCode("schneiders")
        if (schneiders == null) {
            schneiders = new WebCrawler(code: "schneiders", name: "Schneiders", url: "http://cellar.com/winesearcher.aspx", pageType: PageType.HTML,
                    selector: "table#GridView1 tr", currencyCode: "\$", baseUrl: "http://www.cellarit.com.au",
                    usePagination: false, outputTitle: "Name|Price|Vintage|Bottle Size|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: schneiders, wineProperty: WineProperty.WINE_TITLE, selectors: "td:eq(0)", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: schneiders, wineProperty: WineProperty.PRICE, selectors: "td:eq(1)", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: schneiders, wineProperty: WineProperty.VINTAGE, selectors: "td:eq(2)", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: schneiders, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "td:eq(3)", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: schneiders, wineProperty: WineProperty.CUSTOM, customLabel: "URL", selectors: "td:eq(4)", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
        }

        WebCrawler grandvinwinemerchants = WebCrawler.findByCode("grandvinwinemerchants")
        if (grandvinwinemerchants == null) {
            grandvinwinemerchants = new WebCrawler(code: "grandvinwinemerchants", name: "grandvinwinemerchants.com", url: "https://grandvinwinemerchants.com/shop-all/", pageType: PageType.HTML,
                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "page", lastPage: 24, paginationParams: "search_query=&sort=bestselling&category=23&is_category_page=1",
                    maxThreads: 50, selector: "form#frmCompare ul li", currencyCode: "\$", baseUrl: "https://grandvinwinemerchants.com", itemsPerPage: 100, pageLimitName: "limit",
                    digFurther: true, detailsSelectors: "div.ProductMain", detailsLinkSelector: "div.details h4[data-href]", detailsLinkPlacement: DataPlacement.PROPERTY, detailsLinkPropertyName: "data-href",
                    outputTitle: "Name|Price|Vintage|Bottle Size|Appellation|Region|URL|Description").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.WINE_TITLE, selectors: "div.details h4", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.PRICE, selectors: "div.productspace em.p-price span.SalePrice, div.productspace em.p-price",
                    noises: "strike, span", textToRemove: " | ", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.VINTAGE, useDetails: true, detailsSelectors: "div.ProductOtherDetails div.ProductDetailsGrid div:contains(Vintage:) div.value", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.BOTTLE_SIZE, useDetails: true, detailsSelectors: "div.ProductOtherDetails div.ProductDetailsGrid div:contains(Format:) div.value", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.APPELLATION, useDetails: true, detailsSelectors: "div.ProductOtherDetails div.ProductDetailsGrid div:contains(Appellation:) div.value", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.REGION, useDetails: true, detailsSelectors: "div.ProductOtherDetails div.ProductDetailsGrid div:contains(Region:) div.value", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.URL, selectors: "div.details h4[data-href]", dataPlacement: DataPlacement.PROPERTY, propertyName: "data-href", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandvinwinemerchants, wineProperty: WineProperty.DESCRIPTION, selectors: "div.details p.ProductDescription", textToRemove: "\$", dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
        }

        WebCrawler vinchicago = WebCrawler.findByCode("vinchicago")
        if (vinchicago == null) {
            vinchicago = new WebCrawler(code: "vinchicago", name: "VinChicago", url: "http://vinchicago.com/component/customfilters/no-category/no-manuf", pageType: PageType.HTML,
                    selector: "div.row > div.product > div.spacer > div.wdcBrowseRolloverContainer", detailsLinkSelector: "h2 > a.wdcbrowseproducttitle[href]", currencyCode: "\$",
                    usePagination: true, paginationType: PaginationType.LIMIT_OFFSET, itemsPerPage: 100, pageLimitName: "limit", pageOffsetName: "start", lastOffset: 1400,
                    paginationParams: "Itemid=104&limitchange=1&keyword=*", maxThreads: 50, baseUrl: "http://vinchicago.com",
                    outputTitle: "Name|Price|Price Cents|Bottle Size|Description|URL").save(flush: true, failOnError: true)

            def title = new CrawlProperty(webCrawler: vinchicago, wineProperty: WineProperty.WINE_TITLE, selectors: "h2 > a.wdcbrowseproducttitle", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            def price = new CrawlProperty(webCrawler: vinchicago, wineProperty: WineProperty.PRICE, selectors: "div.PricesalesPrice > span.PricesalesPrice", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: vinchicago, wineProperty: WineProperty.CUSTOM, customLabel: "Price Cents", selectors: "div.PricesalesPrice > span.supercents", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: vinchicago, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "div.product-price > div.wdcbottlesize", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: vinchicago, wineProperty: WineProperty.DESCRIPTION, selectors: "div.wdcproductreview > span.wdcproductreviewtext", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: vinchicago, wineProperty: WineProperty.URL, selectors: "h2 > a.wdcbrowseproducttitle[href]", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)

            new PostProcessing(processName: "removeText", processArgs: "\"", processOrder: 0, crawlProperty: title).save(flush: true, failOnError: true)
            new PostProcessing(processName: "concatWithTextAndIndex", processArgs: ".\n2", processOrder: 1, crawlProperty: price).save(flush: true, failOnError: true)
        }

        WebCrawler wineflorida = WebCrawler.findByCode("wineflorida")
        if (wineflorida == null) {
            wineflorida = new WebCrawler(code: "wineflorida", name: "Michael's Fine Wines", url: "http://store.michaelswinecellar.com/search/browse", pageType: PageType.HTML,
                    selector: "div.product-row  > div.grid_prod > div.product_cell", detailsLinkSelector: "div.product_cell_label > a[href]", currencyCode: "\$",
                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "page", lastPage: 61,
                    paginationParams: "q=", maxThreads: 10,
                    outputTitle: "Name|URL|Price").save(flush: true, failOnError: true)

            def title = new CrawlProperty(webCrawler: wineflorida, wineProperty: WineProperty.WINE_TITLE, selectors: "div.product_cell_label > a", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineflorida, wineProperty: WineProperty.URL, selectors: "div.product_cell_label > a[href]", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineflorida, wineProperty: WineProperty.PRICE, selectors: "div.product_cell_label > span.product_cell_price", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)

            new PostProcessing(processName: "removeText", processArgs: ",", processOrder: 0, crawlProperty: title).save(flush: true, failOnError: true)
        }

        WebCrawler woods = WebCrawler.findByCode("woods")
        if (woods == null) {
            woods = new WebCrawler(code: "woods", name: "Woods Wholesale Wine", url: "https://www.woodswholesalewine.com/collections/buy-wine-online", pageType: PageType.HTML,
                    selector: "div.wrapper > div.grid-uniform > div.grid__item.grid-product", detailsLinkSelector: "div.grid-product__wrapper > a.grid-product__meta[href]", currencyCode: "\$",
                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "page", lastPage: 111,
                    paginationParams: "", maxThreads: 50,
                    outputTitle: "Name|URL|Price").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: woods, wineProperty: WineProperty.WINE_TITLE, selectors: "a.grid-product__meta > span.grid-product__title", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: woods, wineProperty: WineProperty.URL, selectors: "div.grid-product__wrapper > a.grid-product__meta[href]", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: woods, wineProperty: WineProperty.PRICE, selectors: "span.grid-product__price-wrap > span.grid-product__price", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
        }

        WebCrawler h2vin = WebCrawler.findByCode("h2vin")
        if (h2vin == null) {
            h2vin = new WebCrawler(code: "h2vin", name: "H2Vin Wines", url: "https://www.h2vin.co.uk/search.php", pageType: PageType.HTML,
                    selector: "div.content > div.products-list > div.item", currencyCode: "£",
                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "page", lastPage: 9,
                    paginationParams: "mode=search&objects_per_page=50", maxThreads: 10, priceIndex: 3,
                    digFurther: true, detailsSelectors: "div#page-container2", detailsLinkSelector: "div.details > a.product-title[href]",
                    outputTitle: "Producer|Name|URL|Price|Vintage|Country|Region|Color|Bottle Size|VAT").save(flush: true, failOnError: true)

            def producer = new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.PRODUCER, useDetails: true, detailsSelectors: "div#location .bread-crumb:nth-last-child(3)", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.WINE_TITLE, selectors: "div.details > a.product-title", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.URL, selectors: "div.details > a.product-title[href]", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            def price = new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.PRICE, selectors: "span.price-value > span.currency", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.VINTAGE, selectors: "div.right-details table tbody tr:eq(0) td", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.COUNTRY, selectors: "div.right-details table tbody tr:eq(1) td", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.REGION, selectors: "div.right-details table tbody tr:eq(2) td", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.COLOR, selectors: "div.right-details table tbody tr:eq(3) td", dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "div.right-details table tbody tr:eq(5) td", dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: h2vin, wineProperty: WineProperty.CUSTOM, customLabel: "VAT", useDetails: true, detailsSelectors: "td.product-price-value", noises: "span, br", dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)

            new PostProcessing(processName: "removeText", processArgs: "£", processOrder: 0, crawlProperty: price).save(flush: true, failOnError: true)
            new PostProcessing(processName: "findAndTakeEverythingBefore", processArgs: ",", processOrder: 1, crawlProperty: producer).save(flush:true, failOnError: true)
        }

        WebCrawler bruun = WebCrawler.findByCode("bruun")
        if (bruun == null) {
            bruun = new WebCrawler(code: "bruun", name: "Bruun Rasmussen", url: "https://bruun-rasmussen.dk/m/categories/2838", pageType: PageType.HTML, baseUrl: "https://bruun-rasmussen.dk",
                    selector: "ul.lots > li[itemscope=itemscope]", detailsLinkSelector: "li[itemscope=itemscope] a[href]", currencyCode: "kr", priceIndex: 4,
                    usePagination: true, paginationType: PaginationType.PAGE_NUMBER, pageNumberName: "page", lastPage: 12,
                    paginationParams: "", maxThreads: 10, detailsSelectors: "main#main",digFurther: true,
                    outputTitle: "Name|URL|Selling Date|Estimate|Next Bid|Description").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.WINE_TITLE, selectors: "div.lot-details > p.description", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.URL, selectors: "li[itemscope=itemscope] a[href]", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.CUSTOM, customLabel: "Selling Date", selectors: "p.hammer-time > time.relative-time", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            def custom1 = new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.CUSTOM, customLabel: "Estimate", selectors: "p.valuation > span.nowrap", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            def custom2 = new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.CUSTOM, customLabel: "Next Bid", selectors: "p.lot-price > span.next-bid-amount", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bruun, wineProperty: WineProperty.DESCRIPTION, useDetails: true, detailsSelectors: "dd.content p", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)

            new PostProcessing(processName: "removeText", processArgs: "kr.", processOrder: 0, crawlProperty: custom1).save(flush: true, failOnError: true)
            new PostProcessing(processName: "removeText", processArgs: "kr.", processOrder: 1, crawlProperty: custom2).save(flush: true, failOnError: true)
        }

    }
}
