import enums.PageType
import enums.Separator
import enums.WineProperty
import wine.alert.CrawlProperty
import wine.alert.WebCrawler

/**
 * Created by marjan on 1/18/17.
 */
class SeparatedValuesNewInit {
    public static init() {

        WebCrawler web21stamendmentcom = WebCrawler.findByCode("21st")
        if (web21stamendmentcom == null) {
            web21stamendmentcom = new WebCrawler(code: "21st", name: "21st Amendment", url: "http://21stamendment.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(wineProperty: WineProperty.WINE_TITLE, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.VINTAGE, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.COUNTRY, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.REGION, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.SUB_REGION, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.APPELLATION, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.BOTTLE_SIZE, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.SELL_PRICE, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.URL, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.PROD_ID, webCrawler: web21stamendmentcom, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler www67wine = WebCrawler.findByCode("67wine")
        if (www67wine == null) {
            www67wine = new WebCrawler(code: "67wine", name: "", url: "http://www.67wine.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: www67wine, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
        }

        WebCrawler allstar = WebCrawler.findByCode("allstar")
        if (allstar == null) {
            allstar = new WebCrawler(code: "allstar", name: "", url: "http://www.paragonspirits.com/winedirectory.asp?source=winealert&request=WLB",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: allstar, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler amity = WebCrawler.findByCode("amity")
        if (amity == null) {
            amity = new WebCrawler(code: "amity", name: "", url: "http://amitywines.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: amity, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler andover = WebCrawler.findByCode("andover")
        if (andover == null) {
            andover = new WebCrawler(code: "andover", name: "", url: "http://www.andoverliquors.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: andover, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler benash = WebCrawler.findByCode("benash")
        if (benash == null) {
            benash = new WebCrawler(code: "benash", name: "", url: "http://benashliquors.com/winedirectory.asp?SOURCE=WINEALERT&REQUEST=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: benash, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler bevmax = WebCrawler.findByCode("bevmax")
        if (bevmax == null) {
            bevmax = new WebCrawler(code: "bevmax", name: "", url: "https://www.bevmax.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bevmax, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler blanchards = WebCrawler.findByCode("blanchard's")
        if (blanchards == null) {
            blanchards = new WebCrawler(code: "blanchard's", name: "", url: "http://www.blanchardsliquor.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: blanchards, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler budgetbottle = WebCrawler.findByCode("budgetbottle")
        if (budgetbottle == null) {
            budgetbottle = new WebCrawler(code: "budgetbottle", name: "Bottleshop Wines", url: "http://www.budgetbottle.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: budgetbottle, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler cappys = WebCrawler.findByCode("cappy's")
        if (cappys == null) {
            cappys = new WebCrawler(code: "cappy's", name: "", url: "http://cappyswineandspirits.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cappys, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler corkscrew = WebCrawler.findByCode("corkscrew")
        if (corkscrew == null) {
            corkscrew = new WebCrawler(code: "corkscrew", name: "", url: "http://www.thecorkscrew.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: corkscrew, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler elephant = WebCrawler.findByCode("elephant")
        if (elephant == null) {
            elephant = new WebCrawler(code: "elephant", name: "", url: "http://www.elephantwine.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: elephant, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler garnet = WebCrawler.findByCode("garnet")
        if (garnet == null) {
            garnet = new WebCrawler(code: "garnet", name: "", url: "http://www.garnetwine.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: garnet, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
        }

        WebCrawler getwineonline = WebCrawler.findByCode("getwineonline")
        if (getwineonline == null) {
            getwineonline = new WebCrawler(code: "getwineonline", name: "", url: "http://www.getwineonline.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: getwineonline, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler gotham = WebCrawler.findByCode("gotham")
        if (gotham == null) {
            gotham = new WebCrawler(code: "gotham", name: "", url: "http://www.gothamwines.com/winedirectory.asp?SOURCE=WINEALERT&REQUEST=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: gotham, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler grandwinecellar = WebCrawler.findByCode("grandwinecellar")
        if (grandwinecellar == null) {
            grandwinecellar = new WebCrawler(code: "grandwinecellar", name: "", url: "http://www.grandwinecellar.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: grandwinecellar, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler internationalwineshop = WebCrawler.findByCode("internationalwineshop")
        if (internationalwineshop == null) {
            internationalwineshop = new WebCrawler(code: "internationalwineshop", name: "", url: "http://www.internationalwineshop.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: internationalwineshop, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler laurenti = WebCrawler.findByCode("laurenti")
        if (laurenti == null) {
            laurenti = new WebCrawler(code: "laurenti", name: "", url: "http://laurentiwines.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laurenti, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler ledu = WebCrawler.findByCode("ledu")
        if (ledu == null) {
            ledu = new WebCrawler(code: "ledu", name: "", url: "http://www.leduwines.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 8, delimiter: Separator.TAB, selector: "pre", saveAsIs: true, charsetEncoding: "ISO-8859-1",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: ledu, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler liquoroutlet = WebCrawler.findByCode("liquoroutlet")
        if (liquoroutlet == null) {
            liquoroutlet = new WebCrawler(code: "liquoroutlet", name: "", url: "http://www.liquoroutletwinecellars.com/winedirectory.asp?request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: liquoroutlet, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler morrell = WebCrawler.findByCode("morrell")
        if (morrell == null) {
            morrell = new WebCrawler(code: "morrell", name: "", url: "http://morrellwine.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: morrell, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler newton = WebCrawler.findByCode("newton")
        if (newton == null) {
            newton = new WebCrawler(code: "newton", name: "", url: "http://www.newtonwines.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: newton, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler oldandrare = WebCrawler.findByCode("oldandrare")
        if (oldandrare == null) {
            oldandrare = new WebCrawler(code: "oldandrare", name: "Old and Rare Wine Co.", url: "http://oldandrarewineco.com/winefeed/winesearcher",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 4, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Price|Bottle Size|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: oldandrare, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: oldandrare, wineProperty: WineProperty.PRICE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: oldandrare, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: oldandrare, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
        }

        WebCrawler post = WebCrawler.findByCode("post")
        if (post == null) {
            post = new WebCrawler(code: "post", name: "", url: "http://postwines.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: post, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler shoprite = WebCrawler.findByCode("shoprite")
        if (shoprite == null) {
            shoprite = new WebCrawler(code: "shoprite", name: "", url: "http://www.shopritewines.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: shoprite, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler skyview = WebCrawler.findByCode("skyview")
        if (skyview == null) {
            skyview = new WebCrawler(code: "skyview", name: "", url: "http://www.skyviewwine.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: skyview, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler suhag = WebCrawler.findByCode("suhag")
        if (suhag == null) {
            suhag = new WebCrawler(code: "suhag", name: "", url: "https://www.suhagwine.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: suhag, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler westchester = WebCrawler.findByCode("westchester")
        if (westchester == null) {
            westchester = new WebCrawler(code: "westchester", name: "", url: "http://westchesterwine.com/winedirectory.asp?SOURCE=WINEALERT&REQUEST=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westchester, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler westside = WebCrawler.findByCode("westside")
        if (westside == null) {
            westside = new WebCrawler(code: "westside", name: "", url: "http://westsidewines.com/winedirectory.asp?SOURCE=WINEALERT&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westside, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler westtrenton = WebCrawler.findByCode("westtrenton")
        if (westtrenton == null) {
            westtrenton = new WebCrawler(code: "westtrenton", name: "", url: "http://www.wtfinewine.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: westtrenton, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler winebuyer = WebCrawler.findByCode("winebuyer")
        if (winebuyer == null) {
            winebuyer = new WebCrawler(code: "winebuyer", name: "", url: "http://thewinebuyer.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winebuyer, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler wineclub = WebCrawler.findByCode("wineclub")
        if (wineclub == null) {
            wineclub = new WebCrawler(code: "wineclub", name: "", url: "http://www.thewineclub.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineclub, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler winefolder = WebCrawler.findByCode("winefolder")
        if (winefolder == null) {
            winefolder = new WebCrawler(code: "winefolder", name: "", url: "https://www.winefolder.com/winedirectory.asp?source=winealert&request=w",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winefolder, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler wineoland = WebCrawler.findByCode("wineoland")
        if (wineoland == null) {
            wineoland = new WebCrawler(code: "wineoland", name: "", url: "http://wineoland.com/winedirectory.asp?SOURCE=WINEALERT&REQUEST=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoland, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler wineoutlet = WebCrawler.findByCode("wineoutlet")
        if (wineoutlet == null) {
            wineoutlet = new WebCrawler(code: "wineoutlet", name: "", url: "http://wineoutlet.com/winedirectory.asp?SOURCE=WINEALERT&REQUEST=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wineoutlet, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler wines4today = WebCrawler.findByCode("wines4today")
        if (wines4today == null) {
            wines4today = new WebCrawler(code: "wines4today", name: "", url: "http://wines4today.com/winedirectory.asp?SOURCE=WINEALERT&REQUEST=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: wines4today, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler winesanywhere = WebCrawler.findByCode("winesanywhere")
        if (winesanywhere == null) {
            winesanywhere = new WebCrawler(code: "winesanywhere", name: "", url: "http://www.winesanywhere.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winesanywhere, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler winewise = WebCrawler.findByCode("winewise")
        if (winewise == null) {
            winewise = new WebCrawler(code: "winewise", name: "", url: "http://www.winewisegreenwich.com/winedirectory.asp?source=winealert&request=W",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: winewise, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }

        WebCrawler yankeespirits = WebCrawler.findByCode("yankeespirits")
        if (yankeespirits == null) {
            yankeespirits = new WebCrawler(code: "yankeespirits", name: "", url: "http://www.yankeespirits.com/winedirectory.asp?source=winealert&request=WLB",
                    pageType: PageType.SEPARATED_VALUES, rowStart: 5, delimiter: Separator.TAB, selector: "pre",
                    outputTitle: "Name|Vintage|Country|Region|Sub Region|Appellation|Bottle Size|Price|URL|PRODID").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.VINTAGE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.COUNTRY, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.REGION, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.SUB_REGION, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.APPELLATION, dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.SELL_PRICE, dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.URL, dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: yankeespirits, wineProperty: WineProperty.PROD_ID, dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
        }


    }
}
