import enums.DataType
import enums.PageType
import enums.Separator
import enums.WineProperty
import wine.alert.CrawlProperty
import wine.alert.PostProcessing
import wine.alert.WebCrawler

/**
 * Created by marjan on 1/22/17.
 */
class XlsInit {
    public static init() {

        WebCrawler belmont = WebCrawler.findByCode("belmont")
        if (belmont == null) {
            belmont = new WebCrawler(code: "belmont", name: "Belmont Wine Exchange", url: "http://site.belmontwine.com/BWE_Inventory.xls", pageType: PageType.EXCEL,
                    minValuesExist: 2, rowStart: 3, outputDelimiter: Separator.PIPE, outputTitle: "Vintage|Name|Bottle Size|Quantity|Price").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: belmont, wineProperty: WineProperty.VINTAGE, dataType: DataType.INTEGER, dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: belmont, wineProperty: WineProperty.WINE_TITLE, dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: belmont, wineProperty: WineProperty.BOTTLE_SIZE, dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: belmont, wineProperty: WineProperty.CUSTOM, customLabel: "Quantity", dataType: DataType.INTEGER, dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: belmont, wineProperty: WineProperty.PRICE, dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
        }
    }
}
