import enums.PageType
import enums.Separator
import enums.WineProperty
import wine.alert.CrawlProperty
import wine.alert.PostProcessing
import wine.alert.WebCrawler

/**
 * Created by marjan on 1/22/17.
 */
class XmlInit {
    public static init() {

        WebCrawler cracka = WebCrawler.findByCode("cracka")
        if (cracka == null) {
            cracka = new WebCrawler(code: "cracka", name: "Cracka", url: "http://feeds.crackawines.com.au.s3.amazonaws.com/Criteo_Com/product.xml", pageType: PageType.XML,
                    selector: "Product", outputTitle: "Name|URL|Price|Description|Bottle Size").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: cracka, wineProperty: WineProperty.WINE_TITLE, selectors: "Product_Name", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cracka, wineProperty: WineProperty.URL, selectors: "Product_URL", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cracka, wineProperty: WineProperty.SELL_PRICE, selectors: "Original_Price", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cracka, wineProperty: WineProperty.DESCRIPTION, selectors: "Product_Description", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: cracka, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "Size", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
        }

        WebCrawler goedhuis = WebCrawler.findByCode("goedhuis")
        if (goedhuis == null) {
            goedhuis = new WebCrawler(code: "goedhuis", name: "Goedhuis & Co.", url: "http://www.goedhuis.com/feed.xml", pageType: PageType.XML,
                    selector: "wine", outputTitle: "SKU|Vintage|Type|Type Description|Start Date|Color|Drink By|Cases Available|Case Size|Producer|Area Name|Grape|Wine Name|Category|Price|Duty Status|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "sku", selectors: "sku", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.VINTAGE, selectors: "year", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            def type = new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "type", selectors: "type", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "type-description", selectors: "type-description", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "start-date", selectors: "start-date", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.COLOR, selectors: "colour", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "drink-by", selectors: "drink-by", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "cases-available", selectors: "cases-available", dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "case-size", selectors: "case-size", dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.PRODUCER, selectors: "producer-name", dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "area-name", selectors: "area-name", dataOutput: true, propertyIndex: 10).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "grape", selectors: "grape", dataOutput: true, propertyIndex: 11).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.WINE_TITLE, selectors: "wine-name", dataOutput: true, propertyIndex: 12).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "wine-category", selectors: "wine-category", dataOutput: true, propertyIndex: 13).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.PRICE, selectors: "price", dataOutput: true, propertyIndex: 14).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.CUSTOM, customLabel: "duty-status", selectors: "duty-status", dataOutput: true, propertyIndex: 15).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: goedhuis, wineProperty: WineProperty.URL, selectors: "link", dataOutput: true, propertyIndex: 16).save(flush: true, failOnError: true)

            new PostProcessing(processName: "replaceWithTextIfIndexEqualsEither", processArgs: "In Bond; Excludes VAT\n15\nIB\nDuty Paid; Excludes VAT", processOrder: 0, crawlProperty: type).save(flush: true, failOnError: true)
        }

        WebCrawler liquiddiscount = WebCrawler.findByCode("liquiddiscount")
        if (liquiddiscount == null) {
            liquiddiscount = new WebCrawler(code: "liquiddiscount", name: "Winezetta.com", url: "http://www.winezetta.com/xml.php?GSF=e6c00bbd/US", pageType: PageType.XML,
                    selector: "entry", outputTitle: "Name|URL|Price|Description").save(flush: true, failOnError: true)

            new CrawlProperty(wineProperty: WineProperty.WINE_TITLE, webCrawler: liquiddiscount, selectors: "title", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.URL, webCrawler: liquiddiscount, selectors: "link", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.SELL_PRICE, webCrawler: liquiddiscount, selectors: "g:price", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.DESCRIPTION, webCrawler: liquiddiscount, selectors: "description", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
        }

        WebCrawler luxurious = WebCrawler.findByCode("luxurious")
        if (luxurious == null) {
            luxurious = new WebCrawler(code: "luxurious", name: "Luxurious Drinks", url: "https://luxurious-drinks.webshopapp.com/en/feed/beslist/", pageType: PageType.XML,
                    selector: "Product", outputTitle: "Name|URL|Price|Description").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: luxurious, wineProperty: WineProperty.WINE_TITLE, selectors: "Titel", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: luxurious, wineProperty: WineProperty.URL, selectors: "Deeplink", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: luxurious, wineProperty: WineProperty.SELL_PRICE, selectors: "Prijs", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: luxurious, wineProperty: WineProperty.DESCRIPTION, selectors: "Product_Description", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
        }

        WebCrawler marketview = WebCrawler.findByCode("marketview")
        if (marketview == null) {
            marketview = new WebCrawler(code: "marketview", name: "Marketview", url: "https://www.marketviewliquor.com/datafeed/productsfeed.xml", pageType: PageType.XML,
                    charsetEncoding: "ISO-8859-1", selector: "item", outputTitle: "Name|URL|Vintage|Price|Country|Description|Bottle Size").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.WINE_TITLE, selectors: "name", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.URL, selectors: "url", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.VINTAGE, selectors: "year", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.SELL_PRICE, selectors: "price", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.COUNTRY, selectors: "country", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.DESCRIPTION, selectors: "description", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: marketview, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "bottle_size", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
        }

        WebCrawler macarthur = WebCrawler.findByCode("macarthur")
        if (macarthur == null) {
            macarthur = new WebCrawler(code: "macarthur", name: "MacArthur Beverages", url: "http://www.bassins.com/winesearcherfeed.xml", pageType: PageType.XML,
                    selector: "wine", outputTitle: "Name|Price|Vintage|Bottle Size|URL").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: macarthur, wineProperty: WineProperty.WINE_TITLE, selectors: "wine-name", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: macarthur, wineProperty: WineProperty.PRICE, selectors: "price", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: macarthur, wineProperty: WineProperty.VINTAGE, selectors: "vintage", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: macarthur, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "bottle-size", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: macarthur, wineProperty: WineProperty.URL, selectors: "link", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
        }

        WebCrawler millesimaAT = WebCrawler.findByCode("millesimaAT")
        if (millesimaAT == null) {
            millesimaAT = new WebCrawler(code: "millesimaAT", name: "Millesima AT", url: "http://admin.millesima.fr/media/productsfeedpick/winealert_at.xml", pageType: PageType.XML,
                    selector: "Produit", outputTitle: "Name|URL|Vintage|Bottle Size|Currency|prixTTC|prixHT").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.WINE_TITLE, selectors: "libelle", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.URL, selectors: "urlinternet", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.VINTAGE, selectors: "millesime", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "volumecontenantml", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.CURRENCY, selectors: "devise", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.CUSTOM, selectors: "prixTTC", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: millesimaAT, wineProperty: WineProperty.CUSTOM, selectors: "prixHT", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
        }

        WebCrawler winehousecom = WebCrawler.findByCode("winehousela")
        if (winehousecom == null) {
            winehousecom = new WebCrawler(code: "winehousela", name: "Wine House (L.A.)", url: "http://www.winehouse.com/productfeed.xml", pageType: PageType.XML,
                    selector: "item", outputTitle: "Name|URL|Vintage|Price").save(flush: true, failOnError: true)

            new CrawlProperty(wineProperty: WineProperty.WINE_TITLE, webCrawler: winehousecom, selectors: "title", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.URL, webCrawler: winehousecom, selectors: "link", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.VINTAGE, webCrawler: winehousecom, selectors: "g:year", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.SELL_PRICE, webCrawler: winehousecom, selectors: "g:price", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.DESCRIPTION, webCrawler: winehousecom, selectors: "description").save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.COLOR, webCrawler: winehousecom, selectors: "style").save(flush: true, failOnError: true)
            new CrawlProperty(wineProperty: WineProperty.CUSTOM, webCrawler: winehousecom, selectors: "department", customLabel: "Department").save(flush: true, failOnError: true)
        }

        WebCrawler laywheeler = WebCrawler.findByCode("laywheeler")
        if (laywheeler == null) {
            laywheeler = new WebCrawler(code: "laywheeler", name: "Lay & Wheeler", url: "https://www.laywheeler.com/feeds/winesearcher.xml", pageType: PageType.XML,
                    selector: "wine", outputTitle: "Name|Vintage|Price|Bottle Size|Colour|Sparkling|Fortified|URL|Custom 1|Custom 2").save(flush: true, failOnError: true)

            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.WINE_TITLE, selectors: "name", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.VINTAGE, selectors: "vintage", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.PRICE, selectors: "price", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "bottle-size", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.COLOR, selectors: "colour", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.CUSTOM, customLabel: "Sparkling", selectors: "sparkling", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.CUSTOM, customLabel: "Fortified", selectors: "fortified", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.URL, selectors: "link", dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            def custom1 = new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.CUSTOM, customLabel: "Custom 1", selectors: "Custom 1", dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            def custom2 = new CrawlProperty(webCrawler: laywheeler, wineProperty: WineProperty.CUSTOM, customLabel: "Custom 2", selectors: "Custom 2", dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)

            new PostProcessing(processName: "replaceWithIndex", processArgs: "0", processOrder: 0, crawlProperty: custom1).save(flush: true, failOnError: true)
            new PostProcessing(processName: "removeText", processArgs: ",", processOrder: 1, crawlProperty: custom1).save(flush: true, failOnError: true)
            new PostProcessing(processName: "replaceWithIndexTakeRight", processArgs: "7\n8", processOrder: 0, crawlProperty: custom2).save(flush: true, failOnError: true)
            new PostProcessing(processName: "concatWithText", processArgs: ";", processOrder: 1, crawlProperty: custom2).save(flush: true, failOnError: true)
        }

        WebCrawler bww = WebCrawler.findByCode("bww")
        if (bww == null) {
            bww = new WebCrawler(code: "bww", name: "Belgium Wine Watchers", url: "http://www.belgiumwinewatchers.com/feed/productxml?language=en&key=winealert2015", pageType: PageType.XML,
                    selector: "Product", outputTitle: "PRODID|Wine Title|Vintage|Bootle Size|Price|Bottler|Description|Stock|URL|VAT").save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.PROD_ID, selectors: "Id", dataOutput: true, propertyIndex: 0).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.WINE_TITLE, selectors: "Name", dataOutput: true, propertyIndex: 1).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.VINTAGE, selectors: "Year", dataOutput: true, propertyIndex: 2).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.BOTTLE_SIZE, selectors: "Volume", dataOutput: true, propertyIndex: 3).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.PRICE, selectors: "Price", dataOutput: true, propertyIndex: 4).save(flush: true, failOnError: true)
            def bottler = new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.CUSTOM, customLabel: "Bottler", selectors: "Bottler", dataOutput: true, propertyIndex: 5).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.DESCRIPTION, selectors: "Description", dataOutput: true, propertyIndex: 6).save(flush: true, failOnError: true)
            new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.CUSTOM, customLabel: "Stock", selectors: "Stock", dataOutput: true, propertyIndex: 7).save(flush: true, failOnError: true)
            def url = new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.CUSTOM, customLabel: "URL", selectors: "Id", dataOutput: true, propertyIndex: 8).save(flush: true, failOnError: true)
            def vat = new CrawlProperty(webCrawler: bww, wineProperty: WineProperty.CUSTOM, selectors: "Id", customLabel: "VAT", dataOutput: true, propertyIndex: 9).save(flush: true, failOnError: true)

            new PostProcessing(processName: "concatReverseWithText", processArgs: "https://www.belgiumwinewatchers.com/en/detail/wines/", processOrder: 0, crawlProperty: url).save(flush: true, failOnError: true)
            new PostProcessing(processName: "removeText", processArgs: "Mc", processOrder: 1, crawlProperty: bottler).save(flush: true, failOnError: true)
            new PostProcessing(processName: "replaceWithText", processArgs: "Excludes VAT", processOrder: 2, crawlProperty: vat).save(flush: true, failOnError: true)
        }
    }
}
