package wine.alert

import groovy.time.TimeCategory
import wine.alert.utils.ServerUtils

/**
 * Cron Job to update the currency rates.
 */
class CurrencyRateJob {
    static triggers = {
        cron name: "UpdateCurrencyRate", cronExpression: "0 59 2 ? * *" // everyday at 2:59am
    }

    def concurrent = false

    def currencyRateService

    def execute() {
        if (!ServerUtils.isDefault()) {
            return
        }

        Date today = new Date()
        log.info("Update Currency Job started.")
        currencyRateService.updateRates()
        log.info("Update Currency Job completed at:" + TimeCategory.minus(new Date(), today))
    }
}
