package wine.alert

import wine.alert.utils.ServerUtils

/**
 * Cron Job to update the history file.<br>
 * Process validated match.<br>
 * Process merging wines.
 */
class HistoryFileUpdaterJob {

    static triggers = {
        simple repeatInterval: 900000l, startDelay: 5000l // execute job once in 15 minutes
    }

    def concurrent = false

    def historyService

    def execute() {
        if (!ServerUtils.isDefault()) {
            return
        }

        historyService.processMatches()
        historyService.processMerges()
    }
}
