package wine.db

import wine.alert.enums.DumpType

/**
 * Cron Job to dump some data to text file.
 */
class DumpJob {
    static triggers = {
        //simple repeatInterval: 5000l // execute job once in 5 seconds
    }

    def concurrent = false

    def downloadService

    def execute(context) {
        String dumpType = context.mergedJobDataMap.get('dumpType')
        if (!downloadService.runningDump) {
            if (dumpType == DumpType.WINE_DB.name()) {
                log.info("WineDb Dump Job started.")
                downloadService.dumpWineDb()
                log.info("WineDb Dump completed.")
            } else if (dumpType == DumpType.MONGO_MAP.name()) {
                log.info("MongoMap Dump Job started.")
                downloadService.dumpMongoMap()
                log.info("MongoMap Dump completed.")
            } else if (dumpType == DumpType.WINE_KEYWORD.name()) {
                log.info("WineKeyword Dump Job started.")
                downloadService.dumpWineKeyword()
                log.info("WineKeyword Dump completed.")
            } else if (dumpType == DumpType.PRODUCER_KEYWORD.name()) {
                log.info("ProducerKeyword Dump Job started.")
                downloadService.dumpProducerKeyword()
                log.info("ProducerKeyword Dump completed.")
            } else if (dumpType == DumpType.GLOBAL_NOISE.name()) {
                log.info("GlobalNoise Dump Job started.")
                downloadService.dumpGlobalNoises()
                log.info("GlobalNoise Dump completed.")
            } else if (dumpType == DumpType.PRODUCER_NOISE.name()) {
                log.info("ProducerNoise Dump Job started.")
                downloadService.dumpProducerNoises()
                log.info("ProducerNoise Dump completed.")
            } else if (dumpType == DumpType.WINE_NOISE.name()) {
                log.info("WineNoise Dump Job started.")
                downloadService.dumpWineNoises()
                log.info("WineNoise Dump completed.")
            }
        } else {
            log.info("Dump Job is currently processing.")
        }
    }
}
