package wine.alert

import com.fasterxml.jackson.databind.ObjectMapper
import grails.plugins.rest.client.RestBuilder
import grails.transaction.Transactional
import org.springframework.beans.factory.annotation.Value
import org.springframework.util.MultiValueMap

@Transactional
class WineRecognitionApiService {

    @Value('${application.api.wine-recognition.url.approve}')
    private String approveApiUrl

    @Value('${application.api.wine-recognition.url.undo}')
    private String undoApiUrl

    @Value('${application.api.wine-recognition.token}')
    private String apiToken

    def restBuilder = new RestBuilder(connectTimeout: 6000, readTimeout:20000)

    Map<String, Object> approveWineLabel(MultiValueMap<String, Object> params) {

        def apiResponse = restBuilder.post(approveApiUrl + params.get("imageName")) {
            header('X-API-Token', apiToken)
            contentType "application/x-www-form-urlencoded"
            body(params)
        }

        return new ObjectMapper().readValue(apiResponse?.responseEntity?.body, HashMap.class)
    }

    Map<String, Object> undoWineLabel(MultiValueMap<String, Object> params) {

        def apiResponse = restBuilder.post(undoApiUrl + params.get("wineId")) {
            header('X-API-Token', apiToken)
            contentType "application/x-www-form-urlencoded"
            body(params)
        }

        return new ObjectMapper().readValue(apiResponse?.responseEntity?.body, HashMap.class)
    }
}
