package wine.db

import grails.transaction.Transactional

/**
 * Service to interact with producer related tables.
 */
@Transactional
class ProducerService {

    /**
     * Checks whether reindex at wine-data API endpoint required.<br>
     *     Have to be called before save the modified instance.
     * @param producer the producer instance
     * @return true if reindex required
     */
    Boolean isWineApiReindexRequired(Producer producer) {
        return producer.isDirty("nameShow")
    }
}
