<%@ page import="wine.alert.enums.DumpType" %>
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'download.label', default: 'Download')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-download" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
            </ul>
        </div>
        <div id="list-download" class="content scaffold-list" role="main">
            <div class="row content-title">
                <div class="col-md-6">
                    <h1><g:message code="default.list.label" args="[entityName]" /></h1>
                </div>
                <div class="col-md-6 text-right">
                    <div class="table-filter">&nbsp;</div>
                </div>
            </div>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <table>
                <thead>
                <tr>
                    <th>Download Name</th>
                    <th>Latest file</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                <tr class="even">
                    <td>Wine Database</td>
                    <td>
                        <g:if test="${wineDbFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.WINE_DB.name()]">download/${wineDbFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.WINE_DB}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.WINE_DB.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                <tr class="odd">
                    <td>Mongomap Database</td>
                    <td>
                        <g:if test="${mongoMapFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.MONGO_MAP.name()]">download/${mongoMapFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.MONGO_MAP}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.MONGO_MAP.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                <tr class="even">
                    <td>Wine Keyword</td>
                    <td>
                        <g:if test="${wineKeywordFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.WINE_KEYWORD.name()]">download/${wineKeywordFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.WINE_KEYWORD}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.WINE_KEYWORD.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                <tr class="odd">
                    <td>Producer Keyword</td>
                    <td>
                        <g:if test="${producerKeywordFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.PRODUCER_KEYWORD.name()]">download/${producerKeywordFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.PRODUCER_KEYWORD}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.PRODUCER_KEYWORD.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                <tr class="even">
                    <td>Global Noise</td>
                    <td>
                        <g:if test="${globalNoiseFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.GLOBAL_NOISE.name()]">download/${globalNoiseFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.GLOBAL_NOISE}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.GLOBAL_NOISE.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                <tr class="odd">
                    <td>Producer Noise</td>
                    <td>
                        <g:if test="${producerNoiseFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.PRODUCER_NOISE.name()]">download/${producerNoiseFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.PRODUCER_NOISE}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.PRODUCER_NOISE.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                <tr class="even">
                    <td>Wine Noise</td>
                    <td>
                        <g:if test="${wineNoiseFileName}">
                            <g:link action="downloadData" params="[dumpType: DumpType.WINE_NOISE.name()]">download/${wineNoiseFileName}</g:link>
                        </g:if>
                    </td>
                    <td>
                        <g:if test="${runningDump == DumpType.WINE_NOISE}">
                            Processing new download
                        </g:if>
                        <g:else>
                            <g:link action="dumpData" params="[dumpType: DumpType.WINE_NOISE.name()]" class="btn btn-default">Generate new download</g:link>
                        </g:else>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>

        <content tag="scripts">
            <script type="text/javascript">
                function ReloadPage() {
                    location.reload();
                }
                setTimeout(ReloadPage, 120000);
            </script>
        </content>
    </body>
</html>