<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'globalNoise.label', default: 'GlobalNoise')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-globalNoise" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="list-globalNoise" class="content scaffold-list" role="main">
            <div class="row content-title">
                <div class="col-md-2">
                    <h1><g:message code="default.list.label" args="[entityName]" /> (${globalNoiseCount})</h1>
                </div>
                <div class="col-md-10 text-right">
                    <g:form action="index" method="GET" class="table-filter form-inline">
                        <label>Search</label>
                        <g:field type="text" name="q" value="${params.get('q')}" class="form-control" />
                        <label><g:message code="globalNoise.dateFrom.label" default="Date From"/></label>
                        <g:field type="date" name="dateFrom" value="${params?.dateFrom}" class="form-control"/>
                        <label><g:message code="globalNoise.dateTo.label" default="Date To"/></label>
                        <g:field type="date" name="dateTo" value="${params?.dateTo}" class="form-control"/>
                        <g:submitButton name="filter" value="${message(code: 'filter.label')}" class="btn btn-default" />
                        <g:actionSubmit value="${message(code: 'globalNoise.download.label', default: 'Download')}" action="download" class="btn btn-default"/>
                    </g:form>
                </div>
            </div>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            %{--<f:table collection="${globalNoiseList}" />--}%

            <div class="freeze-table">
            <table>
                <thead>
                <tr>
                    <g:sortableColumn property="id" title="ID" />
                    <g:sortableColumn property="noise" title="Global Noise" />
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                <g:each in="${globalNoiseList}" var="bean" status="i">
                    <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
                        <td><g:link method="GET" resource="${bean}">${bean.id}</g:link></td>
                        <td>${bean.noise}</td>
                        <td><g:link method="GET" action="delete" id="${bean.id}" class="confirm-delete">Delete</g:link></td>
                    </tr>
                </g:each>
                </tbody>
            </table>
            </div>

            <div class="pagination">
                <g:paginate total="${globalNoiseCount ?: 0}" params="${params}" />
            </div>
        </div>
    </body>
</html>