<!DOCTYPE html>
<html>
  <head>
    <meta name="layout" content="main" />
    <title>Crawler Report</title>
  </head>
  <body>
    <div class="container app-container" role="main">
      <div class="nav" role="navigation">
        <ul>
          <li>
            <a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label" /></a>
          </li>
        </ul>
      </div>
      <div class="row content-title">
        <div class="col-md-6">
          <h1>Crawler Report</h1>
          <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
          </g:if>
        </div>
        <div class="col-md-6">
          <g:link action="report" params="[format: 'xlsx']" class="pull-right text-small">
            <span class="glyphicon glyphicon-download-alt"></span> Export to excel
          </g:link>
        </div>
      </div>

      <div class="row">
        <div class="col-md-3">
          <div class="panel panel-default">
            <div class="panel-heading">
              <h3 class="panel-title">No. of active crawlers</h3>
            </div>
            <div class="panel-body">
                ${crawlerCount}
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="panel panel-default">
            <div class="panel-heading">
              <h3 class="panel-title">No. of successful crawlers</h3>
            </div>
            <div class="panel-body">
              ${successfulCrawlerCount}
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="panel panel-default">
            <div class="panel-heading">
              <h3 class="panel-title">No. of failed crawlers</h3>
            </div>
            <div class="panel-body">
              ${failedCrawlerCount}
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="panel panel-default">
            <div class="panel-heading">
              <h3 class="panel-title">No. of external crawlers</h3>
            </div>
            <div class="panel-body">
              ${externalCrawlerCount}
            </div>
          </div>
        </div>
      </div>

      <div class="panel panel-default panel-table">
        <div class="panel-heading">Crawlers with no change for 5+ successful runs</div>
        <div class="panel-body">
          <table class="table table-scroll">
            <thead>
              <tr>
                <th class="default">code</th>
                <th class="default">no. of days without change</th>
                <th class="default">wine found</th>
                <th class="default">since</th>
              </tr>
            </thead>
            <tbody>
              <g:each in="${crawlersWithNoChange}" var="c">
                <tr>
                  <td>${c['code']}</td>
                  <td>${c['days']}</td>
                  <td>${c['totalRecords']}</td>
                  <td>${c['since']}</td>
                </tr>
              </g:each>
            </tbody>
          </table>
        </div>
      </div>

      <div class="panel panel-default panel-table">
        <div class="panel-heading">Failed Crawlers</div>
        <div class="panel-body">
          <table class="table">
            <thead>
              <tr>
                <th class="default">code</th>
                <th class="default">last success</th>
                <th class="default">page type</th>
              </tr>
            </thead>
            <tbody>
              <g:each in="${failedList}" var="c">
                <tr>
                  <td><g:link controller="webCrawler" action="show" id="${c[3]}" target="_blank">${c[0]}</g:link></td>
                  <td>${c[1]}</td>
                  <td>${c[2]}</td>
                </tr>
              </g:each>
            </tbody>
          </table>
        </div>
      </div>

      <div class="panel panel-default panel-table">
        <div class="panel-heading">html cralwers</div>
        <div class="panel-body">
          <table class="table">
            <thead>
              <tr>
                <th class="default">code</th>
                <th class="default">total records</th>
                <th class="default">daily change</th>
                <th class="default">averange change</th>
              </tr>
              <tbody>
                <g:each in="${htmlCrawlers}" var="c">
                  <tr>
                    <td>${c[1]}</td>
                    <td>${c[2]}</td>
                    <td><g:formatNumber number="${c[3]}" type="percent" maxFractionDigits="2" /></td>
                    <td><g:formatNumber number="${c[4]}" type="percent" maxFractionDigits="2" /></td>
                  </tr>
                </g:each>
              </tbody>
            </thead>
          </table>
        </div>
      </div>

      <div class="panel panel-default panel-table">
        <div class="panel-heading">html async cralwers</div>
        <div class="panel-body">
          <table class="table">
            <thead>
              <tr>
                <th class="default">code</th>
                <th class="default">total records</th>
                <th class="default">daily change</th>
                <th class="default">averange change</th>
              </tr>
              <tbody>
                <g:each in="${htmlAsyncCrawlers}" var="c">
                  <tr>
                    <td>${c[1]}</td>
                    <td>${c[2]}</td>
                    <td><g:formatNumber number="${c[3]}" type="percent" maxFractionDigits="2" /></td>
                    <td><g:formatNumber number="${c[4]}" type="percent" maxFractionDigits="2" /></td>
                  </tr>
                </g:each>
              </tbody>
            </thead>
          </table>
        </div>
      </div>

      <div class="panel panel-default panel-table">
        <div class="panel-heading">crawlers with wine found change >= 20%</div>
        <div class="panel-body">
          <table class="table">
            <thead>
              <tr>
                <th class="default">code</th>
                <th class="default">change</th>
                <th class="default">wine found (today)</th>
                <th class="default">wine found (previous)</th>
              </tr>
              <tbody>
                <g:each in="${crawlersWithRecordChange}" var="c">
                  <tr>
                    <td>${c["code"]}</td>
                    <td><g:formatNumber number="${c["recordChange"]}" type="percent" maxFractionDigits="2" /></td>
                    <td>${c["totalRecords"]}</td>
                    <td>${c["lastTotalRecords"]}</td>
                  </tr>
                </g:each>
              </tbody>
            </thead>
          </table>
        </div>
      </div>

      <div class="panel panel-default panel-table">
        <div class="panel-heading">crawlers with total price change >= 15%</div>
        <div class="panel-body">
          <table class="table">
            <thead>
              <tr>
                <th class="default">code</th>
                <th class="default">change</th>
                <th class="default">currency</th>
                <th class="default">total prices (today)</th>
                <th class="default">total prices (previous)</th>
              </tr>
              <tbody>
                <g:each in="${crawlersWithPriceChange}" var="c">
                  <tr>
                    <td>${c["code"]}</td>
                    <td><g:formatNumber number="${c["priceChange"]}" type="percent" maxFractionDigits="2" /></td>
                    <td>${c["currency"]}</td>
                    <td>${c["totalPrices"]}</td>
                    <td>${c["lastTotalPrices"]}</td>
                  </tr>
                </g:each>
              </tbody>
            </thead>
          </table>
        </div>
      </div>
    </div>
  </body>
</html>
