<%@ page import="enums.RollupType; enums.MatchedType" %>
<!doctype html>
<html lang="en" class="no-js">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge"/>
    <title>
        <g:layoutTitle default="Grails"/>
    </title>
    <meta name="viewport" content="width=device-width, initial-scale=1"/>

    <asset:stylesheet src="application.css"/>

    <g:layoutHead/>
</head>
<body>

    <div class="navbar navbar-default navbar-static-top" role="navigation">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a class="navbar-brand" href="/">
                    %{--<i class="fa grails-icon">
                        <asset:image src="grails-cupsonly-logo-white.svg"/>
                    </i> --}%Wine Match Dashboard
                </a>
            </div>
            <div class="navbar-collapse collapse" aria-expanded="false" style="height: 0.8px;">
                <ul class="nav navbar-nav navbar-right">
                    <sec:ifLoggedIn>
                        <sec:ifAnyGranted roles="ROLE_ADMIN">
                            <li class="dropdown">
                                <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Crawler <span class="caret"></span></a>
                                <ul class="dropdown-menu">
                                    <li><a href="${createLink(controller: 'webCrawler', action: 'index')}">Crawler</a></li>
                                    <li><a href="${createLink(controller: 'retailerGroup', action: 'index')}">Group Crawler</a></li>
                                </ul>
                            </li>
                        <li><a href="${createLink(controller: 'workGroup', action: 'index')}">Work Group</a></li>
                        <li class="dropdown">
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Wine Match <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a href="${createLink(controller: 'wineMatchConfig', action: 'index')}">Match Config</a></li>
                                <li><a href="${createLink(controller: 'wineMatch', action: 'index', params: [matchedType: MatchedType.HISTORY.name()])}">History Match</a></li>
                                <li><a href="${createLink(controller: 'wineMatch', action: 'index', params: [matchedType: MatchedType.KEYWORD.name()])}">Keyword Match</a></li>
                            </ul>
                        </li>
                        %{--<li class="controller">
                            <a href="${createLink(controller: 'rollup', action: 'index', params: [rollupType: RollupType.RP.name()])}">RP Rollup</a>
                        </li>--}%
                        <li class="dropdown">
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Rollup <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a href="${createLink(controller: 'rollup', action: 'index', params: [rollupType: RollupType.RP.name()])}">RP Rollup</a></li>
                                <li><a href="${createLink(controller: 'rollup', action: 'index', params: [rollupType: RollupType.WA.name()])}">WA Rollup</a></li>
                            </ul>
                        </li>
                        <li class="controller">
                            <a href="${createLink(controller: 'download', action: 'index')}">Download</a>
                        </li>
                        <li class="controller">
                            <a href="${createLink(controller: 'app', action: 'validation')}">Validation</a>
                        </li>
                        <li class="controller">
                            <a href="${createLink(controller: 'app', action: 'narrow')}">Narrow</a>
                        </li>
                        </sec:ifAnyGranted>
                        <sec:ifAnyGranted roles="ROLE_ADMIN,ROLE_OPERATION">
                        <li class="dropdown">
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Wine Addition <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <sec:ifAnyGranted roles="ROLE_ADMIN">
                                <li><a href="${createLink(controller: 'app', action: 'addition')}">External Input</a></li>
                                </sec:ifAnyGranted>
                                <sec:ifAnyGranted roles="ROLE_ADMIN,ROLE_OPERATION">
                                <li><a href="${createLink(controller: 'app', action: 'wineSearcher')}">Direct Input</a></li>
                                </sec:ifAnyGranted>
                                <sec:ifAnyGranted roles="ROLE_ADMIN">
                                <li><a href="${createLink(controller: 'app', action: 'keywordGenerator')}">Keyword Generator</a></li>
                                </sec:ifAnyGranted>
                            </ul>
                        </li>
                        </sec:ifAnyGranted>
                        <sec:ifAnyGranted roles="ROLE_ADMIN">
                        <li><a href="${createLink(controller: 'matched', action: 'index')}">Matched</a></li>
                        <li class="dropdown">
                            <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">Noise <span class="caret"></span></a>
                            <ul class="dropdown-menu">
                                <li><a href="${createLink(controller: 'app', action: 'noiseParser')}">Noise Parser</a></li>
                                <li><a href="${createLink(controller: 'globalNoise', action: 'index')}">Global Noise</a></li>
                                <li><a href="${createLink(controller: 'wineNoise', action: 'index')}">Wine Noise</a></li>
                                <li><a href="${createLink(controller: 'producerNoise', action: 'index')}">Producer Noise</a></li>
                            </ul>
                        </li>
                        </sec:ifAnyGranted>
                        <li class="controller">
                            <g:link controller="logout">Logout</g:link>
                        </li>
                    </sec:ifLoggedIn>
                    <g:pageProperty name="page.nav" />
                </ul>
            </div>
        </div>
    </div>

    <g:layoutBody/>

    <div class="footer" role="contentinfo">
        <g:if test="${grails.util.Environment.current != grails.util.Environment.PRODUCTION}">
            <div class="text-center text-white">${grails.util.Environment.current.name}</div>
        </g:if>
    </div>

    <div id="spinner" class="spinner" style="display:none;">
        <g:message code="spinner.alt" default="Loading&hellip;"/>
    </div>

    <asset:javascript src="application.js" charset="utf-8" />
    <g:if test="${controllerName == 'app'}">
        <asset:javascript src="bundle.js" charset="utf-8"/>
    </g:if>

    <g:pageProperty name="page.scripts"/>

</body>
</html>
