<%@ page import="enums.ValidationType" %>
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'matched.label', default: 'Matched')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-matched" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>

        <!-- table -->
        <div id="list-matched" class="content scaffold-list" role="main">
            <div class="row content-title">
                <div class="col-md-2">
                    <h1><g:message code="default.list.label" args="[entityName]" /> (${matchedCount})</h1>
                </div>
                <div class="col-md-10 text-right">
                    <g:form action="index" method="GET" class="table-filter form-inline">
                        <label><g:message code="matched.retailerCode.label" default="Retailer Code"/></label>
                        <g:field type="text" name="code" value="${params?.code}" class="form-control"/>
                        <label><g:message code="matched.dateFrom.label" default="Date From"/></label>
                        <g:field type="date" name="dateFrom" value="${params?.dateFrom}" class="form-control"/>
                        <label><g:message code="matched.dateTo.label" default="Date To"/></label>
                        <g:field type="date" name="dateTo" value="${params?.dateTo}" class="form-control"/>
                        <label><g:message code="matched.validationType.label" default="Validation Type"/></label>
                        <g:select name="validationType" from="${ValidationType.values()}" value="${params?.validationType}" noSelection="['':'All']" class="form-control"/>
                        <label><g:message code="matched.status.label" default="Status"/></label>
                        <g:select name="status" from="['DRAFT', 'PROCESSED']" noSelection="['':'All']" value="${params?.status}" class="form-control"/>
                        <g:submitButton name="filter" value="${g.message(code: 'filter.label')}" class="btn btn-default" />
                        <g:actionSubmit value="${g.message(code: 'matched.download.label', default:'Download')}" action="download" class="btn btn-default"/>
                    </g:form>
                </div>
            </div>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <div class="freeze-table">
            <table>
                <thead>
                <tr>
                    <g:sortableColumn property="webCrawler.code" title="${g.message(code: 'matched.retailerCode.label')}" />
                    <g:sortableColumn property="wineAlertId" title="${g.message(code: 'matched.wineAlertId.label')}" />
                    <th>${g.message(code: 'matched.wineDescription.label')}</th>
                    <g:sortableColumn property="keyword" title="${g.message(code: 'matched.keyword.label')}" />
                    <g:sortableColumn property="description" title="${g.message(code: 'matched.description.label')}" />
                    <g:sortableColumn property="validationType" title="${g.message(code: 'matched.validationType.label')}" />
                    <g:sortableColumn property="status" title="${g.message(code: 'matched.status.label')}" />
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                <g:each in="${matchedList}" var="bean" status="i">
                    <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
                        <td>
                            <g:link action="show" id="${bean.id}" ><f:display bean="${bean}" property="webCrawler.code" displayStyle="table" /></g:link>
                        </td>
                        <td><f:display bean="${bean}" property="wineAlertId" displayStyle="table" /></td>
                        <td>${bean.wineAlertId != 'x' && bean.wineAlertId != 'z' ? wineDbMap?.get(bean.wineAlertId) : ''}</td>
                        <td><f:display bean="${bean}" property="keyword" displayStyle="table" /></td>
                        <td><f:display bean="${bean}" property="description" displayStyle="table" /></td>
                        <td><f:display bean="${bean}" property="validationType" displayStyle="table" /></td>
                        <td><f:display bean="${bean}" property="status"  displayStyle="table" /></td>
                        <td><g:link method="GET" action="delete" id="${bean.id}" class="confirm-delete">Delete</g:link></td>
                    </tr>
                </g:each>
                </tbody>
            </table>
            </div>
            <div class="pagination">
                <g:paginate total="${matchedCount ?: 0}" params="${params}" />
            </div>
        </div>
    </body>
</html>