<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="main" />
    <g:set var="entityName" value="${message(code: 'producerNoise.label', default: 'WineNoise')}" />
    <title><g:message code="default.list.label" args="[entityName]" /></title>
</head>
<body>
<a href="#list-producerNoise" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
<div class="nav" role="navigation">
    <ul>
        <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
        <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
    </ul>
</div>

<!-- table -->
<div id="list-producerNoise" class="content scaffold-list" role="main">
    <div class="row content-title">
        <div class="col-md-2">
            <h1><g:message code="default.list.label" args="[entityName]" /> (${producerNoiseCount})</h1>
        </div>
        <div class="col-md-10 text-right">
            <g:form action="index" method="GET" class="table-filter form-inline">
                <label><g:message code="producerNoise.producer.label" default="Producer ID"/></label>
                <g:field type="text" name="producer.id" value="${params.get('producer.id')}" class="form-control" />
                <label>Search</label>
                <g:field type="text" name="q" value="${params.get('q')}" class="form-control" />
                <label><g:message code="producerNoise.dateFrom.label" default="Date From"/></label>
                <g:field type="date" name="dateFrom" value="${params?.dateFrom}" class="form-control"/>
                <label><g:message code="producerNoise.dateTo.label" default="Date To"/></label>
                <g:field type="date" name="dateTo" value="${params?.dateTo}" class="form-control"/>
                <g:submitButton name="filter" value="${message(code: 'filter.label')}" class="btn btn-default" />
                <g:actionSubmit value="${message(code: 'producerNoise.download.label', default: 'Download')}" action="download" class="btn btn-default"/>
            </g:form>
        </div>
    </div>
    <g:if test="${flash.message}">
        <div class="message" role="status">${flash.message}</div>
    </g:if>
    <div class="freeze-table">
        <table>
            <thead>
            <tr>
                <g:sortableColumn property="id" title="ID" />
                <th>Producer ID</th>
                <g:sortableColumn property="noise" title="Noise" />
                <th>Action</th>
            </tr>
            </thead>
            <tbody>
            <g:each in="${producerNoiseList}" var="bean" status="i">
                <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
                    <td><g:link method="GET" resource="${bean}">${bean.id}</g:link></td>
                    <td>${bean.producer?.id}</td>
                    <td>${bean.noise}</td>
                    <td><g:link method="GET" action="delete" id="${bean.id}" params="['producer.id': bean.producer.id]" class="confirm-delete">Delete</g:link></td>
                </tr>
            </g:each>
            </tbody>
        </table>
    </div>

    <div class="pagination">
        <g:paginate total="${producerNoiseCount ?: 0}" params="${params}" />
    </div>
</div>
</body>
</html>