<%@ page import="enums.Status" %>
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'rollup.label', default: '{0} Rollup', args: [rollupType?.name()])}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-rollupLog" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
            </ul>
        </div>
        <div id="list-rollupLog" class="content scaffold-list" role="main">
            <div class="row content-title">
                <div class="col-md-6">
                    <h1><g:message code="default.list.label" args="[entityName]" /></h1>
                </div>
                <div class="col-md-6 text-right">
                    <div class="table-filter">
                        <button type="button" class="btn btn-default js-rollup__run" data-url="${createLink(action: 'proceed', params: [rollupType: rollupType?.name()])}"
                                data-confirm-msg="${message(code: 'rollup.startJob.label', default: 'Start {0} Rollup Job?', args: [rollupType?.name()])}">
                            <g:message code="rollup.run.label" default="Run {0} Rollup Job" args="[rollupType?.name()]" />
                        </button>
                    </div>
                </div>
            </div>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <div class="freeze-table">
            <table class="js-table">
                <thead>
                <tr>
                    <g:sortableColumn property="dateStart" title="Date Start" />
                    <g:sortableColumn property="dateEnd" title="Date End" />
                    <g:sortableColumn property="message" title="Message" />
                    <g:sortableColumn property="filename" title="File Name" />
                    <g:sortableColumn property="status" title="Status" />
                </tr>
                </thead>
                <tbody>
                <g:each in="${rollupLogList}" var="bean" status="i">
                    <tr class="${(i % 2) == 0 ? 'even' : 'odd'} ${bean.status == Status.RUNNING ? 'js-tr-running' : ''}"
                        data-url="${createLink(action: 'getRollUpLog', id: bean.id, params: [rollupType: rollupType?.name()])}">
                        <td><f:display bean="${bean}" property="dateStart"  displayStyle="'table'" /></td>
                        <td><f:display bean="${bean}" property="dateEnd"  displayStyle="'table'" /></td>
                        <td class="js-td-message"><f:display bean="${bean}" property="message"  displayStyle="'table'" /></td>
                        <td>
                            <g:link action="download" id="${bean.id}" params="[rollupType: rollupType?.name()]">
                                <f:display bean="${bean}" property="filename"  displayStyle="'table'" />
                            </g:link>
                        </td>
                        <td><f:display bean="${bean}" property="status"  displayStyle="'table'" /></td>
                    </tr>
                </g:each>
                </tbody>
            </table>
            </div>

            <div class="pagination">
                <g:paginate total="${rollupLogCount ?: 0}" params="${params}" />
            </div>
        </div>
    </body>
</html>