<div class="freeze-table">
<table>
    <thead>
    <tr>
        <g:each in="${domainProperties}" var="p" status="i">
            <g:set var="propTitle">${domainClass.propertyName}.${p.name}.label</g:set>
            <g:if test="${controllerName == 'webCrawler' && actionName == 'index' && p.name == 'id'}">
                <th><input type="checkbox" name="webCrawlerIdAll" class="checkbox-select-all web-crawler-code-all"
                           data-el-selector="web-crawler-code"/></th>
            </g:if>
            <g:else>
                <g:sortableColumn property="${p.name}" title="${message(code: propTitle, default: p.naturalName)}" />
            </g:else>
        </g:each>
    </tr>
    </thead>
    <tbody>
    <g:each in="${collection}" var="bean" status="i">
        <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
            <g:each in="${domainProperties}" var="p" status="j">
                <g:if test="${controllerName == "webCrawler" && actionName == 'index' && p.name?.equalsIgnoreCase("code")}">
                    <td>
                        <g:link controller="${controllerName}" action="show" id="${bean.id}" >
                            <f:display bean="${bean}" property="${p.name}" displayStyle="${displayStyle ?: 'table'}"/>
                        </g:link>
                    </td>
                </g:if>
                <g:elseif test="${controllerName == "webCrawler" && actionName == 'index' && p.name?.equalsIgnoreCase("id")}">
                    <td>
                        <f:display bean="${bean}" property="${p.name}" displayStyle="${displayStyle ?: 'table'}"/>
                    </td>
                </g:elseif>
                <g:elseif test="${j == 0}">
                    <td>
                        <g:if test="${controllerName}">
                            <g:link controller="${controllerName}" action="show" id="${bean.id}" >
                                <f:display bean="${bean}" property="${p.name}"
                                           displayStyle="${displayStyle ?: 'table'}"/>
                            </g:link>
                        </g:if>
                        <g:else>
                            <g:link method="GET" resource="${bean}">
                                <f:display bean="${bean}" property="${p.name}"
                                           displayStyle="${displayStyle ?: 'table'}"/>
                            </g:link>
                        </g:else>
                    </td>
                </g:elseif>
                <g:elseif test="${bean.class.simpleName.equalsIgnoreCase("webCrawler") && p.name?.equalsIgnoreCase("disabled")}">
                    <td>
                        <g:if test="${bean?.getAt('disabled')==false}">
                            <button class="btn btn-sm btn-default disable-retailer" data-id="${bean?.getAt('id')}" data-toggle="tooltip" data-placement="left"
                                    title="${message(code: 'default.button.clickToDisable.title', default: 'Click to disable {0}', args: [bean?.getAt('code')])}">
                                <g:message code="default.button.enabled.label" default="Enabled" />
                            </button>
                        </g:if>
                        <g:else>
                            <button class="btn btn-sm btn-warning enable-retailer" data-id="${bean?.getAt('id')}" data-toggle="tooltip" data-placement="left"
                                    title="${message(code: 'default.button.clickToEnable.title', default: 'Click to enable {0}', args: [bean?.getAt('code')])}">
                                <g:message code="default.button.disabled.label" default="Disabled" />
                            </button>
                        </g:else>
                    </td>
                </g:elseif>
                <g:elseif test="${bean.class.simpleName.equalsIgnoreCase("webCrawler") && p.name?.equalsIgnoreCase("proceed")}">
                    <td>
                        <g:if test="${bean?.getAt('disabled')==true}">
                            <span class="label label-default disabled-retailer"><g:message code="default.status.disabled.label" default="Disabled" /></span>
                        </g:if>
                        <g:elseif test="${bean?.getAt('proceed')==true}">
                            <span class="label label-primary"><g:message code="default.status.running.label" default="Running" /></span>
                        </g:elseif>
                        <g:else>
                            <button class="btn btn-sm btn-default proceed-retailer" data-id="${bean?.getAt('id')}" data-toggle="tooltip" data-placement="left"
                                    title="${message(code: 'default.button.clickToRun.title', default: 'Click to proceed {0}', args: [bean?.getAt('code')])}">
                                <g:message code="default.button.run.label" default="Run" />
                            </button>
                        </g:else>
                    </td>
                </g:elseif>
                <g:elseif test="${bean.class.simpleName.equalsIgnoreCase("webCrawler") && p.name?.equalsIgnoreCase("latestRun")}">
                    <td>
                        <g:if test="${bean?.getAt('latestRun')}">
                            <g:formatDate date="${bean?.getAt('latestRun')}" format="yyyy-MM-dd HH:mm:ss" />
                        </g:if>
                    </td>
                </g:elseif>
                <g:elseif
                        test="${bean.class.simpleName.equalsIgnoreCase("retailerGroup") && p.name?.equalsIgnoreCase("running")}">
                    <td>
                        <g:if test="${bean?.getAt('running') == true}">
                            <span class="label label-primary">
                                <g:message code="default.status.running.label" default="Running"/>
                            </span>
                        </g:if>
                        <g:else>
                            <g:link controller="retailerGroup" action="run" id="${bean?.getAt('id')}"
                                    class="btn btn-sm btn-default" data-toggle="tooltip" data-placement="left"
                                    title="${message(code: 'default.button.clickToRun.title', default: 'Click to proceed {0}', args: [bean?.getAt('name')])}">
                                <g:message code="default.button.run.label" default="Run"/>
                            </g:link>
                        </g:else>
                    </td>
                </g:elseif>
                <g:else>
                    <td><f:display bean="${bean}" property="${p.name}"  displayStyle="${displayStyle?:'table'}" /></td>
                </g:else>
            </g:each>
        </tr>
    </g:each>
    </tbody>
</table>
</div>