<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'webCrawler.label', default: 'WebCrawler')}" />
        <title>
            <g:message code="default.list.label" args="[entityName]" />
            <g:if test="${grails.util.Environment.current != grails.util.Environment.PRODUCTION}">
                &nbsp;[${grails.util.Environment.current.name}]
            </g:if>
        </title>
    </head>
    <body>
        <a href="#list-webCrawler" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
                <li>
                    <a class="list js-terminate-crawler" href="javascript:void(0);"
                       data-confirmation="${message(code: 'default.confirm.terminate.label', default: 'Terminate {0}?', args: ['selected retailer(s)'])}"
                       data-url="${createLink(controller: 'webCrawler', action: 'terminate')}">
                        <g:message code="default.button.terminateSelected.label" default="Terminate selected" />
                    </a>
                </li>
            </ul>
        </div>
        <div id="list-webCrawler" class="content scaffold-list" role="main">
            <div class="row content-title">
                <div class="col-md-6">
                    <h1><g:message code="default.list.label" args="[entityName]" /></h1>
                </div>
                <div class="col-md-6 text-right">
                    <g:form action="index" method="GET" class="table-filter form-inline">
                        <label class="sr-only">Search</label>
                        <g:field type="text" name="q" value="${params.get('q')}" class="form-control" />
                        <g:submitButton name="find" value="${g.message(code: 'find.label', default: 'Search')}" class="btn btn-default" />
                    </g:form>
                </div>
            </div>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <f:table collection="${webCrawlerList}" properties="['id', 'code', 'name', 'proceed', 'pageType', 'delimiter', 'saveAsIs', 'fileSource', 'latestRun', 'foundRecords', 'disabled']" />

            <div class="pagination">
                <g:paginate total="${webCrawlerCount ?: 0}" params="${params}" />
            </div>
        </div>

        <content tag="scripts">
            <script type="text/javascript">
                var labelEnable = "${message(code: 'default.button.enabled.label', default: 'Enabled')}";
                var labelDisable = "${message(code: 'default.button.disabled.label', default: 'Disabled')}";
                var spanDisabled = '<span class="label label-default disabled-retailer"><g:message code="default.status.disabled.label" default="Disabled" /></span>';
                var spanRun = '<span class="label label-info"><g:message code="default.status.refresh.label" default="Refresh this page" /></span>';

                $(document).ready(function () {
                    $(document).on("click", ".disable-retailer", function () {
                        var _this = $(this);
                        var id = _this.attr("data-id");
                        var runContainer = _this.closest("tr").find(".proceed-retailer").closest("td");
                        var conf = confirm("${message(code: 'default.confirm.disable.label', default: 'Disable {0}?', args: ['retailer'])}");
                        if (conf == true) {
                            $.post("${createLink(controller: 'webCrawler', action: 'disable')}/"+id, function(resp) {
                                _this.removeClass("btn-default disable-retailer").addClass("btn-warning enable-retailer");
                                _this.text(labelDisable);
                                runContainer.html(spanDisabled);
                            }).fail(function() {
                                alert( "Error" );
                            });
                        }
                    });

                    $(document).on("click", ".enable-retailer", function () {
                        var _this = $(this);
                        var id = _this.attr("data-id");
                        var runContainer = _this.closest("tr").find(".disabled-retailer").closest("td");
                        var conf = confirm("${message(code: 'default.confirm.enable.label', default: 'Enable {0}?', args: ['retailer'])}");
                        if (conf == true) {
                            $.post("${createLink(controller: 'webCrawler', action: 'enable')}/"+id, function(resp) {
                                _this.removeClass("btn-warning enable-retailer").addClass("btn-default disable-retailer");
                                _this.text(labelEnable);
                                runContainer.html(spanRun);
                            }).fail(function() {
                                alert( "Error" );
                            });
                        }
                    });

                    $(document).on("click", ".proceed-retailer", function () {
                        var _this = $(this);
                        var id = _this.attr("data-id");
                        var td = _this.closest("td");
                        var conf = confirm("${message(code: 'default.confirm.proceed.label', default: 'Proceed {0}?', args: ['retailer'])}");
                        if (conf == true) {
                            $.post("${createLink(controller: 'webCrawler', action: 'proceed')}/"+id, function(resp) {
                                _this.removeClass("btn-warning enable-retailer").addClass("btn-default disable-retailer");
                                td.html('<span class="label label-primary"><g:message code="default.status.running.label" default="Running" /></span>');
                            }).fail(function() {
                                alert( "Error" );
                            });
                        }
                    });

                    setTimeout(location.reload, 120000);
                });
            </script>
        </content>
    </body>
</html>
