<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'wineDb.label', default: 'WineDb')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-wineDb" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><a id="start-dump-job" class="create" href="javascript:"><g:message code="default.startDumpJob.label" args="[entityName]" /></a></li>
                <li><a id="download" class="create" href="javascript:" disabled="true"><g:message code="default.download.label" args="[entityName]" /></a></li>
            </ul>
        </div>
        <div id="list-wineDb" class="content scaffold-list" role="main">
            <h1><g:message code="default.list.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <f:table collection="${wineDbList}" properties="['id', 'name']" />

            <div class="pagination">
                <g:paginate total="${wineDbCount ?: 0}" />
            </div>
        </div>

        <content tag="scripts">
            <script type="text/javascript">
                function downloadCheck(cb) {
                    $.post("${createLink(action: 'downloadCheck')}", function(resp) {
                        console.log(resp);
                        cb();
                    }).fail(function(err) {
                        console.log(err);
                        cb(err);
                    });
                }

                $(document).ready(function() {

                    $("#start-dump-job").on("click", function () {
                        if (confirm('Start dump job?')) {
                            $(this).text("${message(code: 'default.status.running.label', default: 'Running')}")
                            $.post("${createLink(action: 'startDumpJob')}", function(resp) {
                                console.log(resp);
                                alert("Job is starting");
                            }).fail(function(err) {
                                console.log(err);
                                alert("Error starting job");
                                $(this).text("${message(code: 'default.startDumpJob.label', args: [entityName])}")
                            });
                        }
                    });


                    $("#download").on("click", function () {
                        downloadCheck(function (err) {
                            if (err) {
                                alert("File not yet available");
                                return false;
                            } else {
                                window.location = "${createLink(action: 'download')}";
                            }
                        });
                    });


                });
            </script>
        </content>
    </body>
</html>