<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="entityName" value="${message(code: 'wineLabel.label', default: 'WineLabel')}" />
        <title><g:message code="default.list.label" args="[entityName]" /></title>
    </head>
    <body>
        <a href="#list-wineLabel" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><g:link class="create" action="create"><g:message code="default.new.label" args="[entityName]" /></g:link></li>
            </ul>
        </div>
        <div id="list-wineLabel" class="content scaffold-list" role="main">
            <h1><g:message code="default.list.label" args="[entityName]" /></h1>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <table>
                <thead>
                    <g:sortableColumn property="id" title="${message(code: "wineLabel.id.title", default: "Id")}"/>
                    <th><g:message code="wineLabel.labelImage.title" default="Label Image"/> </th>
                    <th><g:message code="wineLabel.name.title" default="Name"/> </th>
                    <th><g:message code="wineLabel.vintage.title" default="Vintage"/> </th>
                    <th><g:message code="wineLabel.dateSubmitted.title" default="Date Submitted"/> </th>
                    <th><g:message code="wineLabel.status.title" default="Status"/> </th>
                    <th><g:message code="wineLabel.action.title" default="Action"/> </th>
                </thead>
                <tbody>
                    <g:each in="${wineLabelList}" var="wineLabel" status="i">
                        <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
                            <td><g:link controller="wineLabel" action="show" id="${wineLabel?.id}">
                                ${wineLabel?.id}
                            </g:link> </td>
                            <td><img src="${imageMap?.get(wineLabel?.id)}" style="max-height: 70px"></td>
                            <td>${wineLabel?.name}</td>
                            <td>${wineLabel?.vintage}</td>
                            <td>${wineLabel?.submittedDate}</td>
                            <td>
                                <g:if test="${wineLabel?.status == enums.Status.WAIT_FOR_APPROVAL}">
                                    <button class="btn btn-sm btn-danger btn-process" data-url="${createLink(controller: 'wineLabel', action: 'reject', id: wineLabel.id)}">
                                        <g:message code="wineLabel.reject.button" default="Reject"/>
                                    </button>
                                    <button class="btn btn-sm btn-default btn-approve-modal" data-toggle="modal" data-name="${wineLabel.vintage + ' ' + wineLabel.name}" data-image="${wineLabel.imageName}">
                                        <g:message code="wineLabel.approve.button" default="Approve"/>
                                    </button>
                                </g:if>
                                <g:else>
                                    ${wineLabel?.status}<br>
                                    ${wineLabel?.statusUpdated}<br>
                                    <button class="btn btn-sm btn-default btn-process" data-url="${createLink(controller: 'wineLabel', action: 'undo', id: wineLabel.id)}">
                                        <g:message code="wineLabel.undo.button" default="Undo"/>
                                    </button>
                                </g:else>
                            </td>
                            <td>
                                <g:link controller="wineLabel" action="delete" id="${wineLabel.id}">
                                    <g:message code="default.button.delete.label" default="Delete"/>
                                </g:link>
                            </td>
                        </tr>
                    </g:each>
                </tbody>
            </table>

            <div class="pagination">
                <g:paginate total="${wineLabelCount ?: 0}" />
            </div>
        </div>
        <g:render template="modal"/>
        <content tag="scripts">
            <script type="text/javascript">
                $(document).ready(function () {
                    $("body").on("click", ".btn-process", function () {
                        var _this = $(this);
                        var url = _this.data('url')

                        window.location.href = url;
                    });

                    $("body").on("click", ".btn-approve-modal", function () {
                        $("#approveModal").modal('show');
                    })
                })
            </script>
        </content>
    </body>
</html>