<%@ page import="enums.MatchedType; enums.Status" %>
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="main" />
        <g:set var="runKeyword" value="${ MatchedType.KEYWORD.name() == params?.matchedType }"/>
        <g:set var="entityName" value="${message(code: 'wineMatch.label', default: 'WineMatch')}" />
        <title><g:message code="default.list.label" args="[entityName]" /> (${runKeyword ? 'Keyword' : 'History'})</title>
    </head>
    <body>
        <a href="#list-webCrawler" class="skip" tabindex="-1"><g:message code="default.link.skip.label" default="Skip to content&hellip;"/></a>
        <div class="nav" role="navigation">
            <ul>
                <li><a class="home" href="${createLink(uri: '/')}"><g:message code="default.home.label"/></a></li>
                <li><a class="list proceed-match-selected" href="javascript:void(0);"><g:message code="default.button.runSelected.label" default="Proceed selected" /></a></li>
                <li><a class="list js-terminate-selected" href="javascript:void(0);"><g:message code="default.button.terminateSelected.label" default="Terminate selected" /></a></li>
                <li><a class="create download" href="javascript:void(0);" disabled="true"><g:message code="default.download.label" default="Download" args="[entityName]" /></a></li>
            </ul>
        </div>
        <div id="list-webCrawler" class="content scaffold-list" role="main">
            <div class="row content-title">
                <div class="col-md-6">
                    <h1><g:message code="default.list.label" args="[entityName]" /> (${runKeyword ? 'Keyword' : 'History'})</h1>
                </div>
                <div class="col-md-6 text-right">
                    <g:form action="index" method="GET" class="table-filter form-inline">
                        <g:hiddenField name="matchedType" value="${params?.matchedType}" />
                        <label class="sr-only">Search</label>
                        <g:field type="text" name="q" value="${params.get('q')}" class="form-control" />
                        <g:submitButton name="find" value="${message(code: 'find.label', default: 'Search')}" class="btn btn-default" />
                    </g:form>
                </div>
            </div>
            <g:if test="${flash.message}">
                <div class="message" role="status">${flash.message}</div>
            </g:if>
            <div class="freeze-table__2-columns">
            <table>
                <thead>
                <tr>
                    <th><input type="checkbox" class="checkbox-select-all web-crawler-code-all" data-el-selector="web-crawler-code" name="webCrawlerIdAll" /></th>
                    <g:sortableColumn property="code" title="${message(code: 'code.label', default: 'Code')}" />
                    <th><g:message code="wineMatch.proceed.label" default="Proceed" /></th>
                    <th><g:message code="crawlDate.label" default="Input Date" /></th>
                    <th><g:message code="matchedDate.label" default="Matched Date" /></th>
                    <th><g:message code="latestRun.label" default="Latest Run" /></th>
                    <th><g:message code="records.label" default="Record(s)" /></th>
                    <th><g:message code="historyMatched.label" default="History" /></th>
                    <th><g:message code="keywordMatched.label" default="Keyword" /></th>
                    <th><g:message code="ambiguous.label" default="Ambiguous" /></th>
                    <th><g:message code="unknown.label" default="Unknown" /></th>
                    <th><g:message code="status.label" default="Status" /></th>
                </tr>
                </thead>
                <tbody>
                <g:each in="${webCrawlerList}" var="bean" status="i">
                    <g:set var="isProcessing" value="${(runKeyword && runningKeywordMatches?.contains(bean.code)) || (!runKeyword && runningHistoryMatches?.contains(bean.code))}" />
                    <g:set var="inputDate" value="${inputDates?.get(bean.id)}" />
                    <tr class="${(i % 2) == 0 ? 'even' : 'odd'}">
                        <td>
                            <input type="checkbox" class="group-check web-crawler-code" data-el-group="web-crawler-code" data-el-parent="web-crawler-code-all"
                                   name="webCrawlerCode" value="${bean.code}" ${!inputDate ? 'disabled' : ''}/>
                            <g:hiddenField name="runKeyword" value="${ runKeyword }" />
                        </td>
                        <td>${bean.code}</td>
                        <td>
                            <g:if test="${!inputDate}">
                                <span class="label label-default disabled-retailer">No input</span>
                            </g:if>
                            <g:elseif test="${isProcessing}">
                                <span class="label label-primary"><g:message code="default.status.processing.label" default="Processing" /></span>
                            </g:elseif>
                            <g:else>
                                <button class="btn btn-sm btn-default proceed-match" data-code="${bean?.getAt('code')}" data-toggle="tooltip" data-placement="right"
                                        title="${message(code: 'default.button.clickToRun.title', default: 'Click to proceed {0}', args: [bean?.getAt('code')])}">
                                    <g:message code="default.button.run.label" default="Run" />
                                </button>
                            </g:else>
                        </td>
                        <td>
                            <g:if test="${isProcessing}">
                                <g:formatDate date="${inputDate}" format="yyyy-MM-dd" timeZone="GMT" />
                            </g:if>
                            <g:else>
                                <input type="date" name="inputDate" value="${formatDate(date: inputDate, format: 'yyyy-MM-dd', timeZone: 'GMT')}">
                            </g:else>
                        </td>
                        <td>
                            <g:if test="${inputDate}">
                                <g:if test="${runKeyword}">
                                    ${keywordMatchedDates?.containsKey(bean.id) ? formatDate(date: keywordMatchedDates?.get(bean.id), format: 'yyyy-MM-dd', timeZone: 'GMT') : ""}
                                </g:if>
                                <g:else>
                                    ${historyMatchedDates?.containsKey(bean.id) ? formatDate(date: historyMatchedDates?.get(bean.id), format: 'yyyy-MM-dd', timeZone: 'GMT') : ""}
                                </g:else>
                            </g:if>
                        </td>
                        <td>
                            <g:if test="${inputDate}">
                                <g:if test="${runKeyword}">
                                    <g:formatDate date="${bean.latestKeywordMatched?.dateStart}" timeZone="GMT" />
                                </g:if>
                                <g:else>
                                    <g:formatDate date="${bean.latestHistoryMatched?.dateStart}" timeZone="GMT" />
                                </g:else>
                            </g:if>
                        </td>
                        <td>${runKeyword ? bean.latestKeywordMatched?.totalRecords : (bean.latestHistoryMatched?.totalRecords ?: '')}</td>
                        <td>
                            <g:if test="${runKeyword}">
                                ${bean.latestKeywordMatched?.historyMatched != null && inputDate ? bean.latestKeywordMatched?.historyMatched : ""}
                            </g:if>
                            <g:else>
                                ${bean.latestHistoryMatched?.historyMatched != null && inputDate ? bean.latestHistoryMatched?.historyMatched : ""}
                            </g:else>
                        </td>
                        <td>${runKeyword && inputDate ? bean.latestKeywordMatched?.keywordMatched : ''}</td>
                        <td>${runKeyword && inputDate ? bean.latestKeywordMatched?.ambiguousMatched : ''}</td>
                        <td>${runKeyword && inputDate ? bean.latestKeywordMatched?.unknownWines : ''}</td>
                        <td>
                            <g:if test="${inputDate}">
                                <g:if test="${runKeyword}">
                                    ${runningKeywordMatches?.contains(bean.code) ? Status.RUNNING.name() : (bean.latestKeywordMatched?.status?.name() ?: '')}
                                </g:if>
                                <g:else>
                                    ${runningHistoryMatches?.contains(bean.code) ? Status.RUNNING.name() : (bean.latestHistoryMatched?.status?.name() ?: '')}
                                </g:else>
                            </g:if>
                        </td>
                    </tr>
                </g:each>
                </tbody>
            </table>
            </div>

            %{--<div class="pagination">
                <g:paginate total="${webCrawlerCount ?: 0}" />
            </div>--}%
        </div>

        <content tag="scripts">
            <script type="text/javascript">
                $(document).ready(function () {

                    $("table").on("click", ".proceed-match", function () {
                        var _this = $(this);
                        var td = _this.closest("td");
                        var runButton = td.html();
                        var conf = confirm("${message(code: 'default.confirm.proceed.label', default: 'Proceed {0}?', args: ['retailer'])}");

                        var data = {};
                        data.date = $('input[name="date"]').val();
                        data["retailers.0.code"] = _this.attr("data-code");
                        var runKw = _this.closest("tr").find('input[name="runKeyword"]').first();
                        var runKeyword = false;
                        if (runKw.prop("checked")) {
                            runKeyword = true;
                        }
                        data["retailers.0.runKeyword"] = runKeyword;
                        data["retailers.0.date"]  = _this.closest("tr").find('input[name="inputDate"]').first().val();

                        if (conf == true) {
                            td.html('<span class="label label-primary"><g:message code="default.status.processing.label" default="Processing" /></span>');
                            $.post("${raw(createLink(controller: 'wineMatch', action: 'proceed', params: [matchedType: params?.matchedType]))}", data, function(resp) {
                                if (resp.errors && resp.errors.length > 0) {
                                    var e = "";
                                    var i;
                                    for (i in resp.errors) {
                                        e += resp.errors[i] + "\n";
                                    }
                                    alert(e);
                                    td.html(runButton);
                                }
                                location.reload();
                            }, "json").fail(function(resp) {
                                if (resp.responseJSON) alert(resp.responseJSON.message);
                                td.html(runButton);
                                location.reload();
                            });
                        }
                    });

                    $(".nav").on("click", ".proceed-match-selected", function () {
                        var data = {};
                        data.date = $('input[name="date"]').val();
                        var i = 0;
                        $('input[name="webCrawlerCode"]:checked').each(function (e) {
                            data["retailers."+i+".code"] = $(this).val();
                            data["retailers."+i+".date"]  = $(this).closest("tr").find('input[name="inputDate"]').first().val();
                            var runKw = $(this).closest("tr").find('input[name="runKeyword"]').first();
                            if (runKw.prop("checked")) {
                                data["retailers."+i+".runKeyword"] = true;
                            } else {
                                data["retailers."+i+".runKeyword"] = false;
                            }
                            i++;
                        });
                        var conf = confirm("${message(code: 'default.confirm.proceed.label', default: 'Proceed {0}?', args: ['selected retailer(s)'])}");
                        if (conf == true) {
                            $.post("${raw(createLink(controller: 'wineMatch', action: 'proceed', params: [matchedType: params?.matchedType, mode: params?.mode]))}", data, function(resp) {
                                if (resp.errors && resp.errors.length > 0) {
                                    var e = "";
                                    var i;
                                    for (i in resp.errors) {
                                        e += resp.errors[i] + "\n";
                                    }
                                    alert(e);
                                }
                                location.reload();
                            }, "json").fail(function(resp) {
                                if (resp.responseJSON) alert(resp.responseJSON.message);
                                location.reload();
                            });
                        }
                    });

                    $(".nav").on("click", ".js-terminate-selected", function () {
                        var data = {};
                        data.date = $('input[name="date"]').val();
                        var i = 0;
                        $('input[name="webCrawlerCode"]:checked').each(function (e) {
                            data["retailers."+i+".code"] = $(this).val();
                            i++;
                        });
                        var conf = confirm("${message(code: 'default.confirm.terminate.label', default: 'Terminate {0}?', args: ['selected retailer(s)'])}");
                        if (conf == true) {
                            $.post("${raw(createLink(controller: 'wineMatch', action: 'terminate', params: [matchedType: params?.matchedType]))}", data, function(resp) {
                                if (resp.errors && resp.errors.length > 0) {
                                    var e = "";
                                    var i;
                                    for (i in resp.errors) {
                                        e += resp.errors[i] + "\n";
                                    }
                                    alert(e);
                                }
                                location.reload();
                            }, "json").fail(function(resp) {
                                if (resp.responseJSON) alert(resp.responseJSON.message);
                                location.reload();
                            });
                        }
                    });

                    $(".download").on("click", function () {
                        window.location = "${createLink(controller: 'wineMatch', action: 'download', params: [matchedType: params?.matchedType])}";
                    });

                    $('[data-toggle="tooltip"]').tooltip();

                    var dateToday = new Date();
                    var m = ('0' + (dateToday.getMonth() + 1)).substring(((dateToday.getMonth()+1) + "").length-1);
                    var d = ('0' + dateToday.getDate()).substring((dateToday.getDate() + "").length-1);
                    var dateTodayString = dateToday.getFullYear() + '-' + m + '-' + d;
                    $('input[name="date"]').val(dateTodayString);

                    function ReloadPage() {
                        location.reload();
                    }
                    setTimeout(ReloadPage, 120000);
                });
            </script>
        </content>
    </body>
</html>