package enums

/**
 * Created by marjan on 2/17/17.
 */
enum CsvQuoteMode {

    /**
     * Quotes all fields.
     */
    ALL("ALL"),

    /**
     * Quotes fields which contain special characters such as a delimiter, quote character or any of the characters in
     * line separator.
     */
    MINIMAL("MINIMAL"),

    /**
     * Quotes all non-numeric fields.
     */
    NON_NUMERIC("NON_NUMERIC"),

    /**
     * Never quotes fields. When the delimiter occurs in data, it is preceded by the current escape character. If the
     * escape character is not set, printing will throw an exception if any characters that require escaping are
     * encountered.
     */
    NONE("NONE")

    private final String value

    CsvQuoteMode(String value) {
        this.value = value
    }

    String value() { value }

}