package enums

/**
 * Created by marjan on 1/15/17.
 */
enum Separator {

    TAB("TAB", '\t', '\t'),
    SPACE("SPACE", ' ', ''),
    COMMA("COMMA", ',', ","),
    PIPE("PIPE", "|", "\\|"),
    SEMICOLON("SEMICOLON", ";", ";"),
    CUSTOM("CUSTOM", "", "")

    private static Map<String, Separator> map = new HashMap<String, Separator>()
    static {
        for (Separator myEnum : values()) {
            map.put(myEnum.value, myEnum)
        }
    }

    Separator(String name, String value, String delimiter) {
        this.name = name
        this.value = value
        this.delimiter = delimiter
    }

    private final String name
    private final String value
    private final String delimiter

    String value() { value }
    String delimiter() { delimiter }

    public static Separator getByValue(String val) {
        return map.get(val)
    }
}