package wine.alert.crawler

import org.apache.http.MethodNotSupportedException
import wine.alert.crawler.request.CrawlEndpoint
import wine.alert.crawler.request.CrawlRequest
import wine.alert.crawler.response.FeedResponse
import wine.alert.crawler.response.IResponse
import wine.alert.crawler.rest.S3FeedRest

/**
 * Crawler for feed URLs. To get the list of feed endpoint.<br>
 * Currently, only support s3 location.
 */
class FeedCrawler extends AbstractCrawler {

    FeedCrawler(CrawlRequest request) {
        this.request = request
    }

    FeedResponse crawl() {
        return getS3(request.endpoint)
    }

    FeedResponse parse(IResponse response) {
        throw new MethodNotSupportedException("Method parse is not supported by FeedCrawler")
    }

    FeedResponse getS3(CrawlEndpoint endpoint) {
        rest = new S3FeedRest(endpoint)
        return rest.execute()
    }

    IResponse getFixedProps(IResponse response) {
        throw new MethodNotSupportedException("Method getFixedProps is not supported by DynamicCrawler")
    }

    IResponse getAllProps(IResponse response) {
        throw new MethodNotSupportedException("Method getAllProps is not supported by DynamicCrawler")
    }
}
