package wine.alert.crawler

import wine.alert.crawler.response.CrawlResponse
import wine.alert.crawler.response.IResponse

/**
 * Interface for crawler services
 */
interface ICrawler {

    /**
     * Crawls endpoint
     * @return the instance of {@link CrawlResponse}
     */
    IResponse crawl()

    /**
     * Parses the response
     * @param response the response
     * @return the instance of {@link IResponse}
     */
    IResponse parse(IResponse response)

    /**
     * Gets fixed columns data. This method will populate properties from pre-defined settings.
     * @param response the response
     * @return the instance of {@link IResponse}
     */
    IResponse getFixedProps(IResponse response)

    /**
     * Gets all columns data. This method will auto-detect properties.
     * @param response the response
     * @return the instance of {@link IResponse}
     */
    IResponse getAllProps(IResponse response)
}
