/**
 * Request object for crawl
 */

package wine.alert.crawler.request

import groovy.transform.AutoClone
import org.apache.commons.lang3.StringUtils

@AutoClone
class CrawlRequest {
    CrawlEndpoint endpoint
    String baseUrl
    String selector
    List<CrawlElement> elements
    Integer minValueExists
    Integer start = 0
    String separator
    String charset = "UTF-8"

    // Excel
    boolean ooxml = true

    /**
     * Gets base url
     * @return the base url
     */
    String getBaseUrl() {
        if (endpoint && StringUtils.isNotBlank(endpoint.baseUrl)) return endpoint.baseUrl
        return baseUrl
    }
}
