package wine.alert.crawler.rest

import wine.alert.crawler.request.CrawlEndpoint
import wine.alert.crawler.response.CommonResponse

/**
 * Rest service for local file
 */
class FileRest extends AbstractRest {

    private InputStream inputStream

    FileRest(CrawlEndpoint endpoint) {
        this.endpoint = endpoint
    }

    CommonResponse execute() {
        File input = new File(endpoint.url)
        inputStream = new FileInputStream(input)
        new CommonResponse(inputStream: inputStream, charset: endpoint.charset)
    }

    void done() {
        if (inputStream) inputStream.close()
    }
}
