/**
 * Rest service to get an object from ftp service
 */

package wine.alert.crawler.rest

import org.apache.commons.net.ftp.FTPClient
import wine.alert.crawler.request.CrawlEndpoint
import wine.alert.crawler.response.CommonResponse
import wine.alert.crawler.utils.FtpUtils

class FtpRest extends AbstractRest {

    private FTPClient client
    private InputStream inputStream

    FtpRest(CrawlEndpoint endpoint) {
        this.endpoint = endpoint
    }

    CommonResponse execute() {
        client = new FTPClient()
        inputStream = FtpUtils.download(client, endpoint.auth?.userName, endpoint.auth?.password?.toString(), endpoint.url)
        new CommonResponse(inputStream: inputStream, charset: endpoint.charset)
    }

    void done() {
        if (inputStream) inputStream.close()
        if (client.isConnected()) client.disconnect()
    }
}
