/**
 * Rest service to get the list of object URL from aws s3
 */

package wine.alert.crawler.rest

import com.amazonaws.services.s3.AmazonS3Client
import com.amazonaws.services.s3.AmazonS3URI
import wine.alert.crawler.request.CrawlEndpoint
import wine.alert.crawler.response.FeedResponse
import wine.alert.crawler.utils.S3Utils

class S3FeedRest extends AbstractRest {

    S3FeedRest(CrawlEndpoint endpoint) {
        this.endpoint = endpoint
    }

    FeedResponse execute() {
        AmazonS3URI uri = new AmazonS3URI(endpoint.url)
        String region = uri.region ?: endpoint.region
        AmazonS3Client client = S3Utils.getClient(endpoint.auth?.userName, endpoint.auth?.password?.toString(), region)
        List<String> urls = S3Utils.getObjectUrls(client, uri.bucket, uri.key)
        new FeedResponse(urls: urls)
    }

    void done() {
        // no-op
    }
}
