/**
 * Rest service for aws s3 to get an object
 */

package wine.alert.crawler.rest

import com.amazonaws.services.s3.AmazonS3Client
import com.amazonaws.services.s3.AmazonS3URI
import wine.alert.crawler.request.CrawlEndpoint
import wine.alert.crawler.response.CommonResponse
import wine.alert.crawler.utils.S3Utils

class S3Rest extends AbstractRest {

    private InputStream inputStream

    S3Rest(CrawlEndpoint endpoint) {
        this.endpoint = endpoint
    }

    CommonResponse execute() {
        AmazonS3URI uri = new AmazonS3URI(endpoint.url)
        String region = uri.region ?: endpoint.region
        AmazonS3Client client = S3Utils.getClient(endpoint.auth?.userName, endpoint.auth?.password?.toString(), region)
        inputStream = S3Utils.download(client, uri)
        new CommonResponse(inputStream: inputStream, charset: endpoint.charset)
    }

    void done() {
        if (inputStream) inputStream.close()
    }
}
