/**
 * Rest service to get an object from sftp service
 */

package wine.alert.crawler.rest

import com.jcraft.jsch.Session
import wine.alert.crawler.request.CrawlEndpoint
import wine.alert.crawler.response.CommonResponse
import wine.alert.crawler.utils.SftpUtils

class SftpRest extends AbstractRest {

    private static final int DEFAULT_PORT = 22
    private Session session
    private InputStream inputStream

    SftpRest(CrawlEndpoint endpoint) {
        this.endpoint = endpoint
    }

    CommonResponse execute() {
        URL url = new URL(endpoint.url)
        Integer port = endpoint.port ?: DEFAULT_PORT
        session = SftpUtils.createSession(endpoint.auth?.userName, url.host, port, endpoint.auth?.password?.toString())
        inputStream = SftpUtils.download(session, url.path)
        new CommonResponse(inputStream: inputStream, charset: endpoint.charset)
    }

    void done() {
        if (inputStream) inputStream.close()
        if (session) session.disconnect()
    }
}
