package wine.alert.crawler.utils

import com.google.gson.JsonPrimitive
import grails.compiler.GrailsCompileStatic

@GrailsCompileStatic
class JsonUtils {

    /**
     * Gets primitive value
     * @param p the object
     * @return value
     */
    static String readValue(Object p) {
        if (!p) return null
        if (p instanceof JsonPrimitive) {
            if (p.isBoolean()) return p.getAsBoolean().toString()
            if (p.isNumber()) {
                Number n = p.getAsNumber()
                if (n && Math.floor(n) == n) return n.intValue().toString()
            }
            return p.getAsString()
        }
        p.toString()
    }
}
