package wine.alert.model

import groovy.transform.CompileStatic

/**
 * Model for wine match input.
 */
@CompileStatic
class MatchInput {
    private String id
    private String producer
    private String title
    private String vintage
    private String size
    private String bottleSizeId
    private String keywordText
    private String originalKeywordText
    private String historyText
    private String originalHistoryText
    private BigDecimal price
    private String description
    private String sku
    private String taxStatus
    private String url

    MatchInput() {
        this.id = ""
        this.producer = ""
        this.title = ""
        this.vintage = ""
        this.size = ""
        this.price = null
        this.description = ""
        this.sku = ""
        this.taxStatus = ""
        this.url = ""
        this.keywordText = ""
        this.originalKeywordText = ""
        this.historyText = ""
        this.originalHistoryText = ""
    }

    public void setId(String id) {
        this.id = id
    }

    public void setProducer(String producer) {
        this.producer = producer
    }

    public void setTitle(String title) {
        this.title = title
    }

    public void setVintage(String vintage) {
        this.vintage = vintage
    }

    public void setSize(String size) {
        this.size = size
    }

    String getBottleSizeId() {
        return bottleSizeId
    }

    void setBottleSizeId(String bottleSizeId) {
        this.bottleSizeId = bottleSizeId
    }

    public void setPrice(BigDecimal price) {
        this.price = price
    }

    public void setDescription(String description) {
        this.description = description
    }

    public void setSku(String sku) {
        this.sku = sku
    }

    public void setTaxStatus(String taxStatus) {
        this.taxStatus = taxStatus
    }

    public void setUrl(String url) {
        this.url = url
    }

    public String getId() {
        return this.id ?: ""
    }

    public String getProducer() {
        return this.producer ?: ""
    }

    public String getTitle() {
        return this.title ?: ""
    }

    public String getVintage() {
        return this.vintage ?: ""
    }

    public String getSize() {
        return this.size ?: ""
    }

    public BigDecimal getPrice() {
        return this.price
    }

    public String getDescription() {
        return this.description ?: ""
    }

    public String getSku() {
        return this.sku ?: ""
    }

    public String getTaxStatus() {
        return this.taxStatus ?: ""
    }

    public String getUrl() {
        return this.url ?: ""
    }

    public void setKeywordText(String keywordText) {
        this.keywordText = keywordText
    }

    public String getKeywordText() {
        return this.keywordText ?: ""
    }

    String getOriginalKeywordText() {
        return originalKeywordText
    }

    void setOriginalKeywordText(String originalKeywordText) {
        this.originalKeywordText = originalKeywordText
    }

    public void setHistoryText(String historyText) {
        this.historyText = historyText
    }

    public String getHistoryText() {
        return this.historyText ?: ""
    }

    String getOriginalHistoryText() {
        return originalHistoryText
    }

    void setOriginalHistoryText(String originalHistoryText) {
        this.originalHistoryText = originalHistoryText
    }
}
