package wine.alert.model

/**
 * Model for crawler validator result.
 */
class ValidatorResult {
    Integer passedCount
    Integer warnCount
    Integer failedCount
    ArrayList<String> warnProcessList
    ArrayList<String> failedProcessList

    ValidatorResult() {
        this.passedCount = 0
        this.warnCount = 0
        this.failedCount = 0
        this.warnProcessList = []
        this.failedProcessList = []
    }

    public addPass() {
        this.passedCount += 1
    }

    public addWarn(String processName) {
        this.warnCount += 1
        this.warnProcessList.push(processName)
    }

    public addFailed(String processName) {
        this.failedCount += 1
        this.failedProcessList.push(processName)
    }

    public HashMap<?, ?> getResult() {
        return [
                passedCount: this.passedCount,
                warnCount: this.warnCount,
                failedCount: this.failedCount,
                warnProcessList: this.warnProcessList,
                failedProcessList: this.failedProcessList
        ]
    }
}
