package wine.alert.utils

/**
 * Utility for hibernate query language.
 */
class HqlUtils {

    private static final String HIBERNATE_ESCAPE_CHAR = "\\"

    /**
     * Escape sql special characters
     * @return the escaped string
     */
    static escapeHQLParam = { String value ->
        if (!value) return value
        return value
                .replace("\\", HIBERNATE_ESCAPE_CHAR + "\\")
                .replace("_", HIBERNATE_ESCAPE_CHAR + "_")
                .replace("%", HIBERNATE_ESCAPE_CHAR + "%")
                .replace("'", "''")
    }
}
