package wine.db.utils

/**
 * Utility for wine.
 */
class WineUtils {

    /**
     * Gets display name of wine.
     * @param producer the producer show
     * @param label the wine label/name
     * @return the wine display name
     */
    static getDisplayName = { String producer, String label ->
        return concatName(producer, label)
    }

    /**
     * Gets description of wine.
     * @param producer the producer show
     * @param label the wine label/name
     * @param colorClass the wine color class
     * @return the wine description
     */
    static getDescription = { String producer, String label, String colorClass ->
        return concatName(producer, label) + (colorClass ? "  " + colorClass : "")
    }

    /**
     * Concatenates producer show and wine label/name.
     * @param producer the producer show
     * @param label the wine label/name
     * @return the wine display name
     */
    private static String concatName(String producer, String label) {
        if (!label && !producer) return ""
        if (!label) return producer
        if (label.equalsIgnoreCase(producer)) {
            return label
        }
        return producer + " " + label
    }
}
