package wine.alert

import grails.test.mixin.TestFor
import spock.lang.Specification
import wine.db.BottleSize

/**
 * See the API for {@link grails.test.mixin.services.ServiceUnitTestMixin} for usage instructions
 */
@TestFor(KeywordsService)
class KeywordsServiceSpec extends Specification {

    def setupSpec() {
        mockDomain BottleSize
    }

    def setup() {
        Set<BottleSize> set = new HashSet<>(Arrays.asList(
                new BottleSize(
                        id: "75",
                        name: "750 ml - Standard Bottle",
                        alias: "750 ml - Standard Bottle|Bt (75cl)|1x750|750|750ml|75 cl|75cL|750 ml|75cl|0,75|.750l|bottle price (1x75cl)|1×75cl|.750L|Case of 1 Bottles|750 milliliter|0.75 l.|1x75cl|1 X 75Cl|751ML|1/75cl|75|1 bt.|Bottle (75cl)|0,75 l|1 pack in owc|0.75 L|0,750"
                ),
                new BottleSize(
                        id: "12",
                        name: "12 Bottle Case - Standard Bottles",
                        alias: "12 Bottle Case - Standard Bottles|Cs (12x75cl)|12x750|12x75cl|case|12x750|12 X 750ml|750ml case|12 Btl Case|case price (12x75cl)|Case 12|Case of 12 x Bottle|Case of Bottles|12 x 750 ML|12 x 750|12-pack owc|12x750ml|750ml-12pk|Case of btls|Cs|12 bottles|12 pack|12 bs|12 bs (2 oc)|12 bs (2 owc)|12 bs (oc)|12 bs (owc)|12 x 750ml|12×75cl|12xBottles (75cl)|Bottle (Case)|750ml X 12|Case of 750ml|12xbottles|case of 12 bottles|12 X 75cl|12 X 75C|12/75cl|12 bts.|Case (12xBottles, 75cl)|12x75"
                )
        ))
        service.mapBottleAliases(set)
    }

    def cleanup() {
    }

    void "Test for remove size info 1: "() {
        expect:
        Calculator.cleanup(service.removeSizeInfo("1 bt. \"Maya\", Dalla Valle Vineyards, Napa Valley 1993 A (hf/in).")) == "maya dalla valle vineyards napa valley 1993 a hf in"
    }

    void "Test for remove size info 2: "() {
        expect:
        Calculator.cleanup(service.removeSizeInfo("\"Maya\", Dalla Valle Vineyards, Napa Valley 1993 1 bt. A (hf/in).")) == "maya dalla valle vineyards napa valley 1993 a hf in"
    }

    void "Test for remove size info 3: "() {
        expect:
        Calculator.cleanup(service.removeSizeInfo("Ch Lynsolence Grand Cru St Emilion 2000 12x75cl")) == "ch lynsolence grand cru st emilion 2000"
    }
}
