package wine.alert

import grails.test.mixin.TestFor
import spock.lang.Specification

/**
 * See the API for {@link grails.test.mixin.services.ServiceUnitTestMixin} for usage instructions
 */
@TestFor(MatcherService)
class MatcherServiceSpec extends Specification {

    def setupSpec() {
        mockDomain WebCrawler
        mockDomain CrawlProperty
    }

    def setup() {
        WebCrawler webCrawler = new WebCrawler(
                code: "retailer",
                name: "Retailer",
                outputEncoding: "UTF-8",
                keywordIndexes: "0",
                historyIndexes: "1",
                uploadTastingNote: false
        )
        webCrawler.validate()
        webCrawler.save()
    }

    def cleanup() {
    }

    void "Test new session: "() {
        setup:
        WebCrawler webCrawler = WebCrawler.findByCode("retailer")
        webCrawler.historyIndexes = "0,1,2"
        webCrawler.save()

        WebCrawler crawler = null
        WebCrawler.withNewSession {
            crawler = WebCrawler.findByCode("retailer")
            crawler.refresh()
        }
        expect:
        crawler.historyIndexes == webCrawler.historyIndexes
    }

    void "Test new transaction: "() {
        setup:
        WebCrawler webCrawler = WebCrawler.findByCode("retailer")
        webCrawler.historyIndexes = "0,1,2"
        webCrawler.save()

        WebCrawler crawler = null
        WebCrawler.withNewTransaction {
            crawler = WebCrawler.findByCode("retailer")
            crawler.refresh()
        }
        expect:
        crawler.historyIndexes == webCrawler.historyIndexes
    }
}
