package wine.db

import enums.AliasType
import grails.test.mixin.Mock
import grails.test.mixin.TestFor
import spock.lang.Specification
import wine.alert.InputService
import wine.alert.WordAlias

/**
 * See the API for {@link grails.test.mixin.services.ServiceUnitTestMixin} for usage instructions
 */
@Mock([WordAlias])
@TestFor(InputService)
class InputServiceSpec extends Specification {

    def setup() {
    }

    def cleanup() {
    }

    void "deleteUnusedAliases test"() {
        given:
        new WordAlias(word: 'a', alias: 'A', aliasType: AliasType.CUSTOM_CHANGES).save(flush: true)
        new WordAlias(word: 'b', alias: 'B', aliasType: AliasType.CUSTOM_CHANGES).save(flush: true)
        new WordAlias(word: 'b', alias: 'B', aliasType: AliasType.MASS_CHANGES).save(flush: true)

        when:
        Integer c = service.deleteUnusedAliases(['a'], AliasType.CUSTOM_CHANGES)

        then:
        c == 1 && WordAlias.count() == 2
    }
}
